package com.example.kurama.aprieta;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentActivity;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.ImageButton;
import android.widget.Toast;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.math.RoundingMode;
import java.text.DecimalFormat;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;
import static com.google.android.gms.maps.GoogleMap.MAP_TYPE_HYBRID;

public class BoulderMapActivity  extends FragmentActivity implements OnMapReadyCallback {
    Toolbar mToolbar;
    private GoogleMap map;
    private ImageButton backArrow;
    private FusedLocationProviderClient client;
    private Location l;
    private float[] distance = new float[1];
    Double longitude, latitude;

    private DatabaseReference BoulderRef, UserRef;
    private FirebaseAuth mAuth;

    private String currentUserID;
    private Double Latitude, Longitude;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_map);
        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        Latitude = Double.parseDouble(getIntent().getExtras().get("Latitude").toString());
        Longitude = Double.parseDouble(getIntent().getExtras().get("Longitude").toString());
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users").child(currentUserID);

        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);

        backArrow = findViewById(R.id.backarrow);
        backArrow.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent mainIntent = new Intent(BoulderMapActivity.this, MainActivity.class);
                startActivity(mainIntent);
                finish();
            }
        });

        client = LocationServices.getFusedLocationProviderClient(this);


        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            SendUserToMainActivity();
        }else{
            client.getLastLocation().addOnSuccessListener(this, new OnSuccessListener<Location>() {
                @Override
                public void onSuccess(Location location) {
                    if(location==null){
                        Toast.makeText(BoulderMapActivity.this,"Por favor enciende el GPS", Toast.LENGTH_LONG).show();
                    }else{
                        System.out.println(location.toString());
                        l = new Location(location);
                        latitude=location.getLatitude();
                        longitude=location.getLongitude();
                    }
                }
            });
        }

    }
    private void requestPermission(){
        ActivityCompat.requestPermissions(this, new String[]{ACCESS_FINE_LOCATION},1);
    }




    @Override
    public void onMapReady(GoogleMap googleMap) {
        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            SendUserToMainActivity();
        } else {

            map = googleMap;



            // LatLng Actuals = new LatLng(latitude, longitude);
            // map.addMarker(new MarkerOptions().position(Actuals).title("Posición actual").icon(BitmapDescriptorFactory.defaultMarker()));
            map.setMyLocationEnabled(true);
            map.setMapType(MAP_TYPE_HYBRID);


            BoulderRef.addValueEventListener(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if (dataSnapshot.exists()) {
                        for (final DataSnapshot ds : dataSnapshot.getChildren()) {
                            if (latitude == null || longitude == null) {
                                SendUserToSefActivity();
                            }
                            //l.distanceBetween(latitude, longitude, Double.parseDouble(ds.child("latitude").getValue().toString()), Double.parseDouble(ds.child("longitude").getValue().toString()),
                            // distance = new float[1]);

                            UserRef.child("doneBoulders").addValueEventListener(new ValueEventListener() {
                                @Override
                                public void onDataChange(DataSnapshot dataSnapshot) {
                                    DecimalFormat df = new DecimalFormat("#.###");
                                    df.setRoundingMode(RoundingMode.CEILING);
                                    LatLng Usurbil = new LatLng(Double.parseDouble(ds.child("latitude").getValue().toString()), Double.parseDouble(ds.child("longitude").getValue().toString()));

                                    if (dataSnapshot.hasChild(dataSnapshot.child(ds.child("latitude").getValue().toString().replaceAll("\\.", "") + ds.child("longitude").getValue().toString().replaceAll("\\.", "")).getKey())) {
                                        map.addMarker(new MarkerOptions().position(Usurbil).title(ds.child("name").getValue().toString()).snippet("Grados: " + ds.child("grade").getValue().toString() + "  Valoración: " +
                                                ds.child("rate").getValue().toString() + "/5")
                                                .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_CYAN)));
                                    } else {
                                        map.addMarker(new MarkerOptions().position(Usurbil).title(ds.child("name").getValue().toString()).snippet("Grados: " + ds.child("grade").getValue().toString() + "  Valoración: " +
                                                ds.child("rate").getValue().toString() + "/5")
                                                .icon(BitmapDescriptorFactory.defaultMarker(BitmapDescriptorFactory.HUE_RED)));
                                    }

                                }

                                @Override
                                public void onCancelled(DatabaseError databaseError) {

                                }
                            });


                            //System.out.println("Distance from actual to "+ds.child("location").getValue().toString()+" is "+distance[0]);
                        }

                    }
                    LatLng Actual = new LatLng(Latitude, Longitude);
                    map.moveCamera(CameraUpdateFactory.newLatLng(Actual));
                    map.animateCamera(CameraUpdateFactory.newLatLngZoom(Actual, 13));

                    map.setOnInfoWindowClickListener(new GoogleMap.OnInfoWindowClickListener() {
                        @Override
                        public void onInfoWindowClick(Marker marker) {
                            SendUserToBoulderProfileActivity(marker.getPosition().latitude, marker.getPosition().longitude);
                        }
                    });
                    System.out.println(latitude);
                    System.out.println(longitude);

                    map.setOnMapLongClickListener(new GoogleMap.OnMapLongClickListener() {
                        @Override
                        public void onMapLongClick(LatLng latLng) {
                            Double latitude = latLng.latitude;
                            Double longitude = latLng.longitude;
                            SendUserToBoulderActivity(latitude, longitude);
                        }
                    });

                }


                @Override
                public void onCancelled(DatabaseError databaseError) {

                }
            });

        }
    }

    private void SendUserToSefActivity() {
        Intent selfIntent = new Intent(BoulderMapActivity.this, BoulderMapActivity.class);
        startActivity(selfIntent);
        finish();
    }
    private void SendUserToMainActivity() {
        Intent selfIntent = new Intent(BoulderMapActivity.this, MainActivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserToBoulderActivity(double latitude, double longitude) {
        Intent mainIntent = new Intent(BoulderMapActivity.this, BoulderActivity.class);
        mainIntent.putExtra("Latitude", latitude);
        mainIntent.putExtra("Longitude", longitude);
        startActivity(mainIntent);
        finish();
    }

    private void SendUserToBoulderProfileActivity(double latitude, double longitude) {
        Intent mainIntent = new Intent(BoulderMapActivity.this, BoulderProfileActivity.class);
        String lat = String.valueOf(latitude);
        String lon = String.valueOf(longitude);
        mainIntent.putExtra("BoulderKey", lat+lon);
        startActivity(mainIntent);
        finish();
    }
}
