package com.example.kurama.aprieta;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.Exclude;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.squareup.picasso.Picasso;
import com.theartofdev.edmodo.cropper.CropImage;
import com.theartofdev.edmodo.cropper.CropImageView;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;

import de.hdodenhof.circleimageview.CircleImageView;

import static android.view.View.GONE;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;


public class BoulderProfileActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ProgressDialog loadingBar;
    private Uri ImageUri, VideoUri;

    private RecyclerView BoulderImage, BoulderVideo, commentList;
    private TextView boulderName, username, boulderGrade, boulderHeight, boulderLocation, boulderDescription, textView8, textView10;
    private CircleImageView userProfilePic;
    private ImageButton deleteBoulder, addImageBoulder, addVideoBoulder, boulderLike, boulderToDo, boulderCommentButton, boulderMap;
    private RatingBar ratingBoulder, ratingBoulder2;
    private EditText commentInputText;

    private DatabaseReference BoulderRef, UserRef, ChallengeRef;
    private FirebaseAuth mAuth;
    private FirebaseStorage storage;
    private StorageReference boulderImageStorage,actualImageRef;


    private final static int Gallery_Pick = 0;


    private String BoulderKey, currentUserID, boulderImg, boulderStr, boulderNm, boulderDs, boulderGd, boulderLc, latitude, longitude;
    private String numberOfVots, rate;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
            SendUserTo2MainActivity();
        }else{
            super.onBackPressed();
            finish();
        }

    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_boulder_profile);

        requestPermission();

        mToolbar = (Toolbar) findViewById(R.id.boulder_profile_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle("");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        BoulderKey = getIntent().getExtras().get("BoulderKey").toString();
        BoulderKey = BoulderKey.replaceAll("\\.", "");
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders").child(BoulderKey);
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");
        ChallengeRef = FirebaseDatabase.getInstance().getReference().child("Challenges");

        storage = FirebaseStorage.getInstance();
        boulderImageStorage = FirebaseStorage.getInstance().getReference();

        loadingBar = new ProgressDialog(this);

        BoulderImage = findViewById(R.id.boulderProfileImage);
        BoulderImage.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        BoulderImage.setLayoutManager(linearLayoutManager);

        BoulderVideo = findViewById(R.id.boulder_videos);
        BoulderVideo.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManagerVideo = new LinearLayoutManager(this);
        linearLayoutManagerVideo.setReverseLayout(true);
        linearLayoutManagerVideo.setStackFromEnd(true);
        BoulderVideo.setLayoutManager(linearLayoutManagerVideo);


        boulderName = findViewById(R.id.boulderProfileName);
        boulderDescription = findViewById(R.id.boulderProfileDescription2);
        boulderGrade = findViewById(R.id.boulderPrefileGrade2);
        boulderHeight = findViewById(R.id.boulderProfHeight);
        boulderLocation = findViewById(R.id.boulderProfileLocation2);
        deleteBoulder = findViewById(R.id.deleteBoulder);
        addImageBoulder = findViewById(R.id.addMoreImgBoulder);
        addVideoBoulder = findViewById(R.id.addMoreImgBoulder2);
        deleteBoulder.setVisibility(GONE);
        username = findViewById(R.id.boulderOwnerUsername);
        userProfilePic = findViewById(R.id.boulderOwnerProfilePic);
        boulderLike = findViewById(R.id.boulderLike);
        boulderToDo = findViewById(R.id.toDo);
        ratingBoulder = findViewById(R.id.boulderRate);
        ratingBoulder2 = findViewById(R.id.boulderRate2);
        boulderCommentButton = findViewById(R.id.sendBoulderComment);
        commentInputText = findViewById(R.id.boulderComments);
        boulderMap = findViewById(R.id.showBoulderMap);

        textView8 = findViewById(R.id.paNa8);
        textView10 = findViewById(R.id.paNa10);

        commentList = (RecyclerView) findViewById(R.id.boulder_comments);
        commentList.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager2 = new LinearLayoutManager(this);
        linearLayoutManager2.setReverseLayout(true);
        linearLayoutManager2.setStackFromEnd(true);
        commentList.setLayoutManager(linearLayoutManager2);
        commentInputText.setText("");



        ratingBoulder2.setClickable(false);
        ratingBoulder2.setIsIndicator(true);
        ratingBoulder2.setVisibility(View.VISIBLE);

        if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
            boulderCommentButton.setVisibility(View.GONE);
            commentInputText.setVisibility(View.GONE);
            ratingBoulder.setVisibility(GONE);
            ratingBoulder2.setVisibility(GONE);
            boulderLike.setVisibility(GONE);
            boulderToDo.setVisibility(GONE);
            addImageBoulder.setVisibility(GONE);
            addVideoBoulder.setVisibility(GONE);
            textView8.setVisibility(GONE);
            textView10.setVisibility(GONE);

        }

        BoulderRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){

                    boulderDs = dataSnapshot.child("description").getValue().toString();
                    boulderNm = dataSnapshot.child("name").getValue().toString();
                    boulderGd = dataSnapshot.child("grade").getValue().toString();
                    boulderLc = dataSnapshot.child("location").getValue().toString();
                    latitude = dataSnapshot.child("latitude").getValue().toString();
                    longitude = dataSnapshot.child("longitude").getValue().toString();
                    boulderImg = dataSnapshot.child("images").getValue().toString();
                    boulderStr = dataSnapshot.child("profilestorage").getValue().toString();
                    ratingBoulder2.setRating(Integer.parseInt(dataSnapshot.child("rate").getValue().toString()));

                    if(boulderDs.equals("")){
                        boulderDescription.setVisibility(GONE);
                    }
                    if (currentUserID.equals(dataSnapshot.child("userid").getValue().toString()) || currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")) {
                        deleteBoulder.setVisibility(View.VISIBLE);
                    }
                    boulderHeight.setText(dataSnapshot.child("height").getValue().toString()+"m");
                    boulderName.setText(boulderNm);
                    boulderDescription.setText(boulderDs);
                    boulderGrade.setText(boulderGd);
                    boulderLocation.setText(boulderLc);
                    //Picasso.get().load(boulderImg).into(BoulderImage);

                    UserRef.child(dataSnapshot.child("userid").getValue().toString()).addValueEventListener(new ValueEventListener() {
                        @Override
                        public void onDataChange(DataSnapshot dataSnapshot) {
                            if(dataSnapshot.exists()){
                                username.setText(dataSnapshot.child("username").getValue().toString());
                                Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(userProfilePic);
                            }
                        }

                        @Override
                        public void onCancelled(DatabaseError databaseError) {

                        }
                    });

                    if(dataSnapshot.child("Votes").child(currentUserID+"voted").exists()){
                        ratingBoulder.setVisibility(View.GONE);
                        ratingBoulder2.setVisibility(View.VISIBLE);

                    }else if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")) {
                        ratingBoulder.setVisibility(View.GONE);
                        ratingBoulder2.setVisibility(View.GONE);
                    }else{
                        ratingBoulder.setVisibility(View.VISIBLE);
                        ratingBoulder2.setVisibility(View.VISIBLE);

                    }

                    numberOfVots = dataSnapshot.child("numberOfVots").getValue().toString();
                    rate = dataSnapshot.child("rate").getValue().toString();
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        ratingBoulder.setOnRatingBarChangeListener(new RatingBar.OnRatingBarChangeListener() {
            @Override
            public void onRatingChanged(RatingBar ratingBar, float rating, boolean fromUser) {
                double actualRate = (double) ratingBar.getRating();
                if (actualRate != 0) {
                    double totalRatess = Double.parseDouble(numberOfVots) + 1;
                    double storedRatess = Double.parseDouble(rate);
                    double avgRates = (storedRatess + actualRate) / totalRatess;
                    int avgRate = (int) Math.round(avgRates);
                    int totalRates = (int) totalRatess;


                    BoulderRef.child("numberOfVots").setValue(String.valueOf(totalRates));
                    BoulderRef.child("rate").setValue(String.valueOf(avgRate));

                    HashMap hash = new HashMap();
                    hash.put(currentUserID+"voted", currentUserID);

                    BoulderRef.child("Votes").updateChildren(hash);
                    ratingBoulder2.setRating(avgRate);
                    ratingBar.setVisibility(GONE);
                    ratingBoulder2.setVisibility(View.VISIBLE);

                } else {
                    Toast.makeText(BoulderProfileActivity.this, "No se puede votar con 0", Toast.LENGTH_LONG).show();
                }
            }

        });



        UserRef.child(currentUserID).child("likeBoulder").addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(final DataSnapshot dataSnapshot) {
                if(dataSnapshot.child(BoulderKey).exists()) {
                    boulderLike.setImageResource(R.drawable.like);

                    boulderLike.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            boulderLike.setImageResource(R.drawable.dislike);
                            UserRef.child(currentUserID).child("likeBoulder").child(BoulderKey).removeValue();
                        }
                    });
                }else{
                    boulderLike.setImageResource(R.drawable.dislike);

                    boulderLike.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            boulderLike.setImageResource(R.drawable.like);
                            HashMap boulderLike =new HashMap();
                            boulderLike.put(BoulderKey, BoulderKey);
                            UserRef.child(currentUserID).child("likeBoulder").child(BoulderKey).updateChildren(boulderLike);
                        }
                    });
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {
            }
        });

        UserRef.child(currentUserID).child("toDoBoulders").addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.child(BoulderKey).exists()) {
                    boulderToDo.setImageResource(R.drawable.tododone);

                    boulderToDo.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            boulderToDo.setImageResource(R.drawable.todonodone);
                            UserRef.child(currentUserID).child("toDoBoulders").child(BoulderKey).removeValue();
                        }
                    });
                }else{
                    boulderToDo.setImageResource(R.drawable.todonodone);

                    boulderToDo.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            boulderToDo.setImageResource(R.drawable.tododone);
                            HashMap boulderToDo =new HashMap();
                            boulderToDo.put(BoulderKey, BoulderKey);
                            UserRef.child(currentUserID).child("toDoBoulders").updateChildren(boulderToDo);
                        }
                    });
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        boulderMap.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToMapActivity();
            }
        });

        addImageBoulder.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToEnsurePicActivity();
            }
        });

        addVideoBoulder.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToEnsureVideoActivity();
            }
        });

        boulderCommentButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                UserRef.child(currentUserID).addListenerForSingleValueEvent(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if(dataSnapshot.exists()){
                            String username = dataSnapshot.child("username").getValue().toString();
                            String profilepic = dataSnapshot.child("profileimage").getValue().toString();
                            validateComment(username, profilepic);
                            commentInputText.setText("");
                        }
                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });
            }
        });


        deleteBoulder.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AlertDialog.Builder builder = new AlertDialog.Builder(BoulderProfileActivity.this);
                builder.setTitle(R.string.boulder_profile_AlertB);
                builder.setPositiveButton(R.string.boulder_profile_removeAlert, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        BoulderRef.child("BoulderImages").addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()) {
                                    for (DataSnapshot ds : dataSnapshot.getChildren()) {
                                        actualImageRef = storage.getReferenceFromUrl(ds.child("profilestorage").getValue().toString());
                                        actualImageRef.delete();
                                    }
                                }
                            }
                            @Override
                            public void onCancelled(DatabaseError databaseError) {}
                        });

                        BoulderRef.child("BoulderVideos").addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()) {
                                    for (DataSnapshot ds : dataSnapshot.getChildren()) {
                                        if(storage.getReferenceFromUrl(ds.child("videostorage").getValue().toString())!=null) {
                                            actualImageRef = storage.getReferenceFromUrl(ds.child("videostorage").getValue().toString());
                                            actualImageRef.delete();
                                        }
                                    }
                                }
                            }
                            @Override
                            public void onCancelled(DatabaseError databaseError) {}
                        });

                        BoulderRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                actualImageRef = storage.getReferenceFromUrl(dataSnapshot.child("profilestorage").getValue().toString());
                                actualImageRef.delete();
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        UserRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                for(DataSnapshot ds : dataSnapshot.getChildren()){
                                    if(dataSnapshot.child(ds.getKey()).child("toDoBoulders").exists()){
                                        UserRef.child(ds.getKey()).child("toDoBoulders").child(BoulderKey).removeValue();
                                    }
                                    if(dataSnapshot.child(ds.getKey()).child("doneBoulders").exists()){
                                        UserRef.child(ds.getKey()).child("doneBoulders").child(BoulderKey).removeValue();
                                    }
                                    if(dataSnapshot.child(ds.getKey()).child("likeBoulder").exists()){
                                        UserRef.child(ds.getKey()).child("likeBoulder").child(BoulderKey).removeValue();
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        ChallengeRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()){
                                    for(final DataSnapshot ds : dataSnapshot.getChildren()){
                                        if(ds.child("Boulders").child(BoulderKey).exists()){
                                            ChallengeRef.child(ds.getKey()).child("Boulders").child(BoulderKey).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                                @Override
                                                public void onComplete(@NonNull Task<Void> task) {
                                                    if(task.isSuccessful()){
                                                        BoulderRef.removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                                            @Override
                                                            public void onComplete(@NonNull Task<Void> task) {
                                                                if(task.isSuccessful()) {
                                                                    Toast.makeText(BoulderProfileActivity.this, R.string.boulder_profile_removenoty, Toast.LENGTH_SHORT).show();
                                                                    if (ds.child("Boulders").getChildrenCount()== 1) {
                                                                        ChallengeRef.child(ds.getKey()).removeValue();
                                                                        UserRef.addListenerForSingleValueEvent(new ValueEventListener() {
                                                                            @Override
                                                                            public void onDataChange(DataSnapshot dataSnapshot) {
                                                                                for(DataSnapshot ds2 : dataSnapshot.getChildren()){
                                                                                    if(dataSnapshot.child(ds2.getKey()).child("OwnChallenges").hasChild(ds.getKey())){
                                                                                        UserRef.child(ds2.getKey()).child("OwnChallenges").child(ds.getKey()).removeValue();
                                                                                    }
                                                                                }
                                                                            }

                                                                            @Override
                                                                            public void onCancelled(DatabaseError databaseError) {

                                                                            }
                                                                        });
                                                                    }
                                                                    if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                                                                        SendUserTo2MainActivity();
                                                                    }else {
                                                                        SendUserToMainActivity();
                                                                    }

                                                                }

                                                            }
                                                        });

                                                    }
                                                }
                                            });

                                        }else{
                                            BoulderRef.removeValue();
                                            Toast.makeText(BoulderProfileActivity.this, R.string.boulder_profile_removenoty, Toast.LENGTH_SHORT).show();
                                            if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                                                SendUserTo2MainActivity();
                                            }else {
                                                SendUserToMainActivity();
                                            }
                                        }
                                    }
                                }else {
                                    BoulderRef.removeValue();
                                    Toast.makeText(BoulderProfileActivity.this, R.string.boulder_profile_removenoty, Toast.LENGTH_SHORT).show();
                                    if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                                        SendUserTo2MainActivity();
                                    }else {
                                        SendUserToMainActivity();
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                    }
                });
                builder.setNegativeButton(R.string.boulder_profile_cancelAlert, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        dialog.cancel();
                    }
                });
                AlertDialog dialog = builder.create();
                dialog.show();

            }
        });
        displayAllComents();
        displayBoulderImages();
        displayBoulderVideos();

    }

    private void requestPermission(){
        ActivityCompat.requestPermissions(this, new String[]{WRITE_EXTERNAL_STORAGE},1);
    }

    private void validateComment(String username, String profilepic) {
        String commentText = commentInputText.getText().toString();
        if(TextUtils.isEmpty(commentText)){
            Toast.makeText(this, R.string.comment_addver, Toast.LENGTH_SHORT).show();
        }else{
            Calendar date = Calendar.getInstance();
            SimpleDateFormat currentDate = new SimpleDateFormat("dd-MM-yyyy");
            final String saveCurrentDate = currentDate.format(date.getTime());

            Calendar time = Calendar.getInstance();
            SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
            final String saveCurrentTime = currentTime.format(time.getTime());

            final String  commentRandomName = currentUserID + saveCurrentDate + saveCurrentTime;

            HashMap commentsMap = new HashMap();
            commentsMap.put("uid", currentUserID);
            commentsMap.put("comment", commentText);
            commentsMap.put("date", saveCurrentDate);
            commentsMap.put("time", saveCurrentTime);
            commentsMap.put("username", username);
            commentsMap.put("profileimage", profilepic);

            BoulderRef.child("Comments").child(commentRandomName).updateChildren(commentsMap).addOnCompleteListener(new OnCompleteListener() {
                @Override
                public void onComplete(@NonNull Task task) {
                    if(task.isSuccessful()){
                    }else{
                        Toast.makeText(BoulderProfileActivity.this, "Error", Toast.LENGTH_SHORT).show();
                    }
                }
            });



        }
    }

    private void displayBoulderImages() {
        Query SortPostInDescending = BoulderRef.child("BoulderImages").orderByKey();

        FirebaseRecyclerOptions<BoulderImgs> options = new FirebaseRecyclerOptions.Builder<BoulderImgs>().setQuery(SortPostInDescending, BoulderImgs.class).build();
        FirebaseRecyclerAdapter<BoulderImgs, BoulderProfileActivity.BoulderImagesViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<BoulderImgs, BoulderProfileActivity.BoulderImagesViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull BoulderImagesViewHolder holder, final int position, @NonNull BoulderImgs model) {
                Picasso.get().load(model.getProfileimage()).into(holder.img);
                holder.img.setOnLongClickListener(new View.OnLongClickListener() {
                    @Override
                    public boolean onLongClick(View v) {
                        AlertDialog.Builder builder = new AlertDialog.Builder(BoulderProfileActivity.this);
                        builder.setTitle(R.string.boulder_profile_AlertD);
                        builder.setPositiveButton(R.string.boulder_profile_removeAlert, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                BoulderRef.child("BoulderImages").child(getRef(position).getKey()).addValueEventListener(new ValueEventListener() {
                                    @Override
                                    public void onDataChange(DataSnapshot dataSnapshot) {
                                        if(dataSnapshot.exists()) {
                                            String imageRef = dataSnapshot.child("profilestorage").getValue().toString();
                                            String imgKey = getRef(position).getKey();
                                            deleteImage(imageRef, imgKey);
                                        }

                                    }

                                    @Override
                                    public void onCancelled(DatabaseError databaseError) {

                                    }
                                });

                            }
                        });
                        builder.setNegativeButton(R.string.boulder_profile_cancelAlert, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                dialog.cancel();
                            }
                        });
                        AlertDialog dialog = builder.create();
                        dialog.show();
                        return true;
                    }
                });

            }

            @NonNull
            @Override
            public BoulderImagesViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.display_all_boulder_images_layout,parent,false);
                BoulderProfileActivity.BoulderImagesViewHolder viewHolder=new BoulderProfileActivity.BoulderImagesViewHolder(view);
                return viewHolder;            }
        };
        BoulderImage.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }

    private void deleteImage(String imageRef, String imgKey) {
        actualImageRef = storage.getReferenceFromUrl(imageRef);
        actualImageRef.delete();
        BoulderRef.child("BoulderImages").child(imgKey).removeValue();
    }

    public static class BoulderImagesViewHolder extends RecyclerView.ViewHolder{
        TextView videoTitle;
        ImageButton remove;
        RatingBar ratingBar, ratingBar2;
        ImageView img;
        public BoulderImagesViewHolder(View itemView){
            super(itemView);
            img = itemView.findViewById(R.id.boulderProfileImage2);
            videoTitle = itemView.findViewById(R.id.video_title);
            remove = itemView.findViewById(R.id.removeVideo);
            ratingBar = itemView.findViewById(R.id.video_rate);
            ratingBar2 = itemView.findViewById(R.id.video_rate2);

        }
    }

    private void displayBoulderVideos() {
        Query SortPostInDescending = BoulderRef.child("BoulderVideos").orderByKey();

        FirebaseRecyclerOptions<BoulderVds> options = new FirebaseRecyclerOptions.Builder<BoulderVds>().setQuery(SortPostInDescending, BoulderVds.class).build();
        FirebaseRecyclerAdapter<BoulderVds, BoulderProfileActivity.BoulderImagesViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<BoulderVds, BoulderProfileActivity.BoulderImagesViewHolder>(options) {
            @SuppressLint("ClickableViewAccessibility")
            @Override
            protected void onBindViewHolder(@NonNull final BoulderImagesViewHolder holder, final int position, @NonNull final BoulderVds model) {
                holder.remove.setVisibility(GONE);
                holder.videoTitle.setText(model.getVideoTitle());

                holder.itemView.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent videoIntent = new Intent(BoulderProfileActivity.this, BoulderVideoActivity.class);
                        videoIntent.putExtra("BoulderKey", BoulderKey);
                        videoIntent.putExtra("VideoKey", getRef(position).getKey());
                        startActivity(videoIntent);
                    }
                });

                if (currentUserID.equals(model.getUserID()) || currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")) {
                    holder.remove.setVisibility(View.VISIBLE);
                    holder.remove.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            BoulderRef.child("BoulderVideos").addListenerForSingleValueEvent(new ValueEventListener() {
                                @Override
                                public void onDataChange(DataSnapshot dataSnapshot) {
                                    String videoKey = getRef(position).getKey();
                                    String videoRef = dataSnapshot.child(videoKey).child("videostorage").getValue().toString();
                                    deleteVideo(videoRef, videoKey);
                                }

                                @Override
                                public void onCancelled(DatabaseError databaseError) {}
                            });


                        }
                    });
                }
                holder.ratingBar2.setClickable(false);
                holder.ratingBar2.setIsIndicator(true);
                holder.ratingBar2.setVisibility(View.VISIBLE);
                holder.ratingBar.setVisibility(GONE);
                holder.ratingBar2.setRating(Integer.parseInt(model.getRate()));


                if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                    holder.ratingBar.setVisibility(GONE);
                    holder.ratingBar2.setVisibility(GONE);
                }

            }







            @NonNull
            @Override
            public BoulderImagesViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_video_layout,parent,false);
                BoulderProfileActivity.BoulderImagesViewHolder viewHolder=new BoulderProfileActivity.BoulderImagesViewHolder(view);
                return viewHolder;
            }
        };
        BoulderVideo.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }

    private void deleteVideo(String videoRef, String videoKey) {
        actualImageRef = storage.getReferenceFromUrl(videoRef);
        actualImageRef.delete();
        BoulderRef.child("BoulderVideos").child(videoKey).removeValue();
    }

    private void displayAllComents(){
        FirebaseRecyclerOptions<Comments> options=new FirebaseRecyclerOptions.Builder<Comments>().setQuery(BoulderRef.child("Comments"),Comments.class).build();
        FirebaseRecyclerAdapter<Comments, BoulderProfileActivity.CommentsViewHolder> firebaseRecyclerAdapter=new FirebaseRecyclerAdapter<Comments, BoulderProfileActivity.CommentsViewHolder>(options){
            @Override
            protected void onBindViewHolder(@NonNull final BoulderProfileActivity.CommentsViewHolder holder, int position, @NonNull final Comments model) {

                final String CommentKey = getRef(position).getKey();
                UserRef.child(model.getUid()).addListenerForSingleValueEvent(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if(dataSnapshot.exists()){
                            holder.username.setText(dataSnapshot.child("username").getValue().toString());
                            holder.comment.setText(model.getComment());
                            holder.date.setText(model.getDate());
                            holder.time.setText(model.getTime());
                            Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(holder.profileImage);

                            if(currentUserID.equals(model.getUid()) || currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                                holder.deleteComment.setVisibility(View.VISIBLE);

                                holder.deleteComment.setOnClickListener(new View.OnClickListener() {
                                    @Override
                                    public void onClick(View v) {
                                        BoulderRef.child("Comments").child(CommentKey).removeValue();
                                    }
                                });
                            }else if(!currentUserID.equals(model.getUid()) || !currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                                holder.deleteComment.setVisibility(GONE);
                            }
                        }
                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });

            }

            @NonNull
            @Override
            public BoulderProfileActivity.CommentsViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_comments_layout,parent,false);
                BoulderProfileActivity.CommentsViewHolder viewHolder=new BoulderProfileActivity.CommentsViewHolder(view);
                return viewHolder;
            }

        };
        commentList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }

    public static class CommentsViewHolder extends RecyclerView.ViewHolder{

        TextView username, comment, date, time;
        CircleImageView profileImage;
        ImageButton deleteComment;

        View mView;
        public CommentsViewHolder(View itemView) {
            super(itemView);

            mView = itemView;

            username = mView.findViewById(R.id.all_user_comment_username);
            comment = mView.findViewById(R.id.all_user_comments);
            date = mView.findViewById(R.id.dateComments);
            time = mView.findViewById(R.id.timeComments);
            profileImage = mView.findViewById(R.id.all_users_comments_profile_image);
            deleteComment = mView.findViewById(R.id.delete_Comment);
        }
    }


    private void SendUserToMainActivity() {
        Intent mainIntent = new Intent(BoulderProfileActivity.this, MainActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }

    private void SendUserTo2MainActivity() {
        Intent mainIntent = new Intent(BoulderProfileActivity.this, Main2Activity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }


    private void SendUserToEnsurePicActivity() {
        Intent mainIntent = new Intent(BoulderProfileActivity.this, EnsurePicActivity.class);
        mainIntent.putExtra("BoulderKey", BoulderKey);
        startActivity(mainIntent);
        finish();
    }

    private void SendUserToEnsureVideoActivity() {
        Intent mainIntent = new Intent(BoulderProfileActivity.this, EnsureVideoActivity.class);
        //mainIntent.putExtra("video", downloadURL1);
        mainIntent.putExtra("BoulderKey", BoulderKey);
        //mainIntent.putExtra("VideoUri", VideoUri);
        startActivity(mainIntent);
        finish();
    }
    private void SendUserToMapActivity(){
        Intent mapIntent = new Intent(BoulderProfileActivity.this, BoulderMapActivity.class);
        mapIntent.putExtra("Latitude", latitude);
        mapIntent.putExtra("Longitude", longitude);
        startActivity(mapIntent);
        finish();
    }

}
