package com.example.kurama.aprieta;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.squareup.picasso.Picasso;
import com.theartofdev.edmodo.cropper.CropImage;
import com.theartofdev.edmodo.cropper.CropImageView;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;

import de.hdodenhof.circleimageview.CircleImageView;

import static android.view.View.GONE;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;


public class BoulderProfileMapActivity extends AppCompatActivity {

    private Toolbar mToolbar;

    private RecyclerView BoulderImage;
    private TextView boulderName, username, boulderGrade, boulderHeight, boulderLocation, boulderDescription;
    private CircleImageView userProfilePic;
    private ImageButton boulderMap;

    private DatabaseReference BoulderRef, UserRef;

    private String latitude, longitude, boulderNm, boulderDs, boulderGd, boulderLc, BoulderKey;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.boulder_profile_notloged_activity);

        mToolbar = (Toolbar) findViewById(R.id.notLogedboulder_profile_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle("");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        BoulderKey = getIntent().getExtras().get("BoulderKey").toString();
        BoulderKey = BoulderKey.replaceAll("\\.", "");

        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders").child(BoulderKey);
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");


        BoulderImage = findViewById(R.id.notLogedboulderProfileImage);
        BoulderImage.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        BoulderImage.setLayoutManager(linearLayoutManager);


        boulderName = findViewById(R.id.notLogedboulderProfileName);
        boulderDescription = findViewById(R.id.notLogedboulderProfileDescription2);
        boulderGrade = findViewById(R.id.notLogedboulderPrefileGrade2);
        boulderHeight = findViewById(R.id.notLogedboulderProfHeight);
        boulderLocation = findViewById(R.id.notLogedboulderProfileLocation2);
        username = findViewById(R.id.notLogedboulderOwnerUsername);
        userProfilePic = findViewById(R.id.notLogedboulderOwnerProfilePic);
        boulderMap = findViewById(R.id.notLogedshowBoulderMap);


        BoulderRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){
                    boulderDs = dataSnapshot.child("description").getValue().toString();
                    boulderNm = dataSnapshot.child("name").getValue().toString();
                    boulderGd = dataSnapshot.child("grade").getValue().toString();
                    boulderLc = dataSnapshot.child("location").getValue().toString();
                    latitude = dataSnapshot.child("latitude").getValue().toString();
                    longitude = dataSnapshot.child("longitude").getValue().toString();

                    if(boulderDs.equals("")){
                        boulderDescription.setVisibility(View.GONE);
                    }

                    boulderHeight.setText(dataSnapshot.child("height").getValue().toString()+"m");
                    boulderName.setText(boulderNm);
                    boulderDescription.setText(boulderDs);
                    boulderGrade.setText(boulderGd);
                    boulderLocation.setText(boulderLc);
                    //Picasso.get().load(boulderImg).into(BoulderImage);

                    UserRef.child(dataSnapshot.child("userid").getValue().toString()).addValueEventListener(new ValueEventListener() {
                        @Override
                        public void onDataChange(DataSnapshot dataSnapshot) {
                            if(dataSnapshot.exists()){
                                username.setText(dataSnapshot.child("username").getValue().toString());
                                Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(userProfilePic);
                            }
                        }

                        @Override
                        public void onCancelled(DatabaseError databaseError) {

                        }
                    });

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });


        boulderMap.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToMapActivity();
            }
        });

        displayBoulderImages();
    }


    private void displayBoulderImages() {
        Query SortPostInDescending = BoulderRef.child("BoulderImages").orderByKey();

        FirebaseRecyclerOptions<BoulderImgs> options = new FirebaseRecyclerOptions.Builder<BoulderImgs>().setQuery(SortPostInDescending, BoulderImgs.class).build();
        FirebaseRecyclerAdapter<BoulderImgs, BoulderProfileMapActivity.BoulderImagesViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<BoulderImgs, BoulderProfileMapActivity.BoulderImagesViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull BoulderProfileMapActivity.BoulderImagesViewHolder holder, final int position, @NonNull BoulderImgs model) {
                Picasso.get().load(model.getProfileimage()).into(holder.img);
            }

            @NonNull
            @Override
            public BoulderProfileMapActivity.BoulderImagesViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.display_all_boulder_images_layout,parent,false);
                BoulderProfileMapActivity.BoulderImagesViewHolder viewHolder=new BoulderProfileMapActivity.BoulderImagesViewHolder(view);
                return viewHolder;            }
        };
        BoulderImage.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }

    public static class BoulderImagesViewHolder extends RecyclerView.ViewHolder{
        ImageView img;
        public BoulderImagesViewHolder(View itemView){
            super(itemView);
            img = itemView.findViewById(R.id.boulderProfileImage2);


        }
    }

    private void SendUserToMapActivity(){
        Intent mapIntent = new Intent(BoulderProfileMapActivity.this, BoulderMapNotLogedActivity.class);
        mapIntent.putExtra("Latitude", latitude);
        mapIntent.putExtra("Longitude", longitude);
        startActivity(mapIntent);
        finish();
    }

}
