package com.example.kurama.aprieta;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.location.Location;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.OnSuccessListener;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;

public class ChooseBoulderAddActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private FusedLocationProviderClient client;

    TextView currentLocal, mapLocal;
    ImageButton imgcurrentLocal, imgmapLocal;
    Double longitude, latitude;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_choose_boulder_add);

        mToolbar = (Toolbar) findViewById(R.id.choose_boulder_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.add_boulder_option_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        client = LocationServices.getFusedLocationProviderClient(this);

        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            return;
        }
        client.getLastLocation().addOnSuccessListener(this, new OnSuccessListener<Location>() {
            @Override
            public void onSuccess(Location location) {
                if(location==null){
                    Toast.makeText(ChooseBoulderAddActivity.this,"Por favor enciende el GPS", Toast.LENGTH_LONG).show();
                }else{
                    System.out.println(location.getProvider());
                    latitude=location.getLatitude();
                    longitude=location.getLongitude();
                }
            }
        });
        currentLocal = findViewById(R.id.actualLocal);
        mapLocal = findViewById(R.id.mapLocal);
        imgcurrentLocal = findViewById(R.id.imagenotLogedBoulderSearch);
        imgmapLocal = findViewById(R.id.imageMapLocal);

        currentLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgcurrentLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToBoulderActivity();
            }
        });

        imgcurrentLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgcurrentLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToBoulderActivity();
            }
        });

        mapLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgmapLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToMapActivity();
            }
        });

        imgmapLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgmapLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToMapActivity();
            }
        });

    }


    private void SendUserToMapActivity() {
        Intent mapIntent = new Intent(ChooseBoulderAddActivity.this, MapActivity.class);
        startActivity(mapIntent);
        finish();
    }

    private void SendUserToBoulderActivity() {
        Intent boulderIntent = new Intent(ChooseBoulderAddActivity.this, BoulderActivity.class);
        boulderIntent.putExtra("Latitude", latitude);
        boulderIntent.putExtra("Longitude", longitude);
        startActivity(boulderIntent);
        finish();
    }
}
