package com.example.kurama.aprieta;

import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.media.Image;
import android.media.MediaPlayer;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.MediaController;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.support.v7.widget.Toolbar;
import android.widget.VideoView;

import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.squareup.picasso.Picasso;

public class ClickPostAcitivity extends AppCompatActivity {
    private Toolbar mToolbar;

    private ImageView PostImage;
    private TextView PostDescription;
    private Button DeleteButton, EditButton;
    private VideoView videoView;

    private RelativeLayout relativeLayout;
    private RelativeLayout.LayoutParams params;


    private DatabaseReference ClickPostRef;
    private FirebaseStorage storage;
    private StorageReference postStoreRef;
    private FirebaseAuth mAuth;

    private String PostKey, currentUserID, description, image, uid, type;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_click_post_acitivity);

        mToolbar = (Toolbar) findViewById(R.id.click_post_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle("");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        relativeLayout = findViewById(R.id.forHide);
        params = new RelativeLayout.LayoutParams(0, 0);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        PostKey = getIntent().getExtras().get("PostKey").toString();
        type = getIntent().getExtras().get("type").toString();
        ClickPostRef = FirebaseDatabase.getInstance().getReference().child("Post").child(PostKey);
        storage = FirebaseStorage.getInstance();


        PostImage = (ImageView) findViewById(R.id.postEditImage);
        videoView = findViewById(R.id.postEditVideo);
        PostDescription = (TextView) findViewById(R.id.postdescription);
        DeleteButton = (Button) findViewById(R.id.deletePost);
        EditButton = (Button) findViewById(R.id.editPost);

        DeleteButton.setVisibility(View.INVISIBLE);
        EditButton.setVisibility(View.INVISIBLE);

        if(type.equals("image")){
            videoView.setVisibility(View.GONE);
            PostImage.setVisibility(View.VISIBLE);
        }else if(type.equals("video")){
            videoView.setVisibility(View.VISIBLE);
            PostImage.setVisibility(View.GONE);
        }else if(type.equals("text")){
            relativeLayout.setLayoutParams(params);
        }

        ClickPostRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if (dataSnapshot.exists()) {
                    description = dataSnapshot.child("status").getValue().toString();
                    image = dataSnapshot.child("postimage").getValue().toString();
                    uid = dataSnapshot.child("uid").getValue().toString();

                    if(description.equals("")){
                        PostDescription.setVisibility(View.INVISIBLE);
                    }
                    if (currentUserID.equals(uid) || currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")) {
                        DeleteButton.setVisibility(View.VISIBLE);
                        EditButton.setVisibility(View.VISIBLE);
                    }
                    PostDescription.setText(description);
                    if(type.equals("image")){
                        Picasso.get().load(image).into(PostImage);
                        postStoreRef = storage.getReferenceFromUrl(dataSnapshot.child("storedpath").getValue().toString());

                    }else if(type.equals("video")){
                        postStoreRef = storage.getReferenceFromUrl(dataSnapshot.child("storedpath").getValue().toString());
                        videoView.setVideoPath(image);
                        videoView.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                            @Override
                            public void onPrepared(MediaPlayer mp) {
                                MediaController mediaController = new MediaController(ClickPostAcitivity.this);
                                mediaController.setAnchorView(videoView);
                                videoView.setMediaController(mediaController);
                                videoView.start();
                            }
                        });
                    }
                }
            }
            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        DeleteButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AlertDialog.Builder builder = new AlertDialog.Builder(ClickPostAcitivity.this);
                builder.setTitle(R.string.post_delete_noty);
                builder.setPositiveButton(R.string.boulder_profile_removeAlert, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        DeleteCurrentPost();

                    }
                });
                builder.setNegativeButton(R.string.post_edit_cancel, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        dialog.cancel();
                    }
                });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
        });

        EditButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EditCurrentPost(description);

            }
        });
    }

    private void EditCurrentPost(String description) {
        AlertDialog.Builder builder = new AlertDialog.Builder(ClickPostAcitivity.this);
        builder.setTitle(R.string.edit_title);

        final EditText inputField = new EditText(ClickPostAcitivity.this);
        inputField.setText(description);
        builder.setView(inputField);

        builder.setPositiveButton(R.string.post_edit_update, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                if(type.equals("text")){
                    if(!inputField.getText().toString().equals("") && inputField.getText().toString() != null){
                        ClickPostRef.child("status").setValue(inputField.getText().toString());
                        Toast.makeText(ClickPostAcitivity.this, R.string.edit_noty, Toast.LENGTH_SHORT).show();

                    }else{
                        Toast.makeText(ClickPostAcitivity.this, R.string.post_status_noty, Toast.LENGTH_SHORT).show();
                    }
                }else{
                    ClickPostRef.child("status").setValue(inputField.getText().toString());
                    Toast.makeText(ClickPostAcitivity.this, R.string.edit_noty, Toast.LENGTH_SHORT).show();

                }
                if(!ClickPostRef.child("status").equals("")) PostDescription.setVisibility(View.VISIBLE);
                else PostDescription.setVisibility(View.GONE);
            }
        });

        builder.setNegativeButton(R.string.post_edit_cancel, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });

        Dialog dialog = builder.create();
        dialog.show();
        dialog.getWindow().setBackgroundDrawableResource(android.R.color.darker_gray);
    }

    private void DeleteCurrentPost() {
        if(type.equals("image") || type.equals("video"))postStoreRef.delete();

        ClickPostRef.removeValue();

        SendUserToMainActivity();
        Toast.makeText(this, R.string.edit_noty_delete, Toast.LENGTH_SHORT).show();
    }

    private void SendUserToMainActivity() {
        Intent mainIntent = new Intent(ClickPostAcitivity.this, MainActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }
}
