package com.example.kurama.aprieta;

import android.content.Intent;
import android.graphics.Canvas;
import android.support.annotation.NonNull;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.support.v7.widget.helper.ItemTouchHelper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;

import java.util.HashMap;

public class DoneBoulderListAcitivity extends AppCompatActivity {
    private Toolbar mToolbar;

    private RecyclerView bouldersList;

    private StorageReference postImageReference;
    private DatabaseReference BoulderRef, UserRef;
    private FirebaseAuth mAuth;
    private String currentUserID, BoulderKey;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_done_boulder_list_acitivity);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users").child(currentUserID);
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        postImageReference = FirebaseStorage.getInstance().getReference();

        mToolbar = (Toolbar) findViewById(R.id.doneBoulderList_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.toDoBoulders_doneBoulders);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        bouldersList = (RecyclerView) findViewById(R.id.doneBoulders_list);
        bouldersList.setHasFixedSize(true);
        bouldersList.setLayoutManager(new LinearLayoutManager(this));

        displayDoneBoulders();
    }

    private void displayDoneBoulders() {
        Query searchBoulders = BoulderRef.orderByChild("name");

        FirebaseRecyclerOptions<FindBoulders> options = new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders, FindBoulders.class).build();
        final FirebaseRecyclerAdapter<FindBoulders, ToDoActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, ToDoActivity.FindBouldersViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final ToDoActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                final String BoulderKey = getRef(position).getKey();
                UserRef.child("doneBoulders").addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if(dataSnapshot.exists()) {
                            if (dataSnapshot.child(BoulderKey).exists()) {
                                holder.name.setText(model.getName());
                                holder.location.setText(model.getLocation());
                                holder.grade.setText(model.getGrade());
                                holder.mView.setOnClickListener(new View.OnClickListener() {
                                    @Override
                                    public void onClick(View v) {
                                        Intent boulderProfileIntent = new Intent(DoneBoulderListAcitivity.this, BoulderProfileActivity.class);
                                        boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                        startActivity(boulderProfileIntent);
                                        finish();

                                    }
                                });
                            }else{
                                holder.linearLayout.removeAllViewsInLayout();
                                holder.linearLayout.setVisibility(View.GONE);
                                holder.Layout_hide();
                            }
                        }else{
                            holder.linearLayout.removeAllViewsInLayout();
                            holder.linearLayout.setVisibility(View.GONE);
                            holder.Layout_hide();
                        }
                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });



            }

            @NonNull
            @Override
            public ToDoActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout, parent, false);
                ToDoActivity.FindBouldersViewHolder viewHolder = new ToDoActivity.FindBouldersViewHolder(view);
                return viewHolder;
            }
        };
        bouldersList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();

    }

}
