package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.net.Uri;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.theartofdev.edmodo.cropper.CropImage;
import com.theartofdev.edmodo.cropper.CropImageView;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;

import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

public class EnsurePicActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ProgressDialog loadingBar;

    private Uri ImageUri;
    private ImageView img;
    private Button save;

    private StorageReference boulderImageStorage;
    private FirebaseStorage storage;
    private DatabaseReference BoulderRef;
    private HashMap hashBoulder;
    private String  BoulderKey, downloadURL1, storages, saveCurrentDate, saveCurrentTime, boulderRandomName;

    private final static int Gallery_Pick = 0;


    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ensure_pic);
        loadingBar = new ProgressDialog(this);

        mToolbar = (Toolbar) findViewById(R.id.ensurepic_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.ensure_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        if (ActivityCompat.checkSelfPermission(this, WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ) {
            Toast.makeText(this, "Para subir una foto debes aceptar los permisos!", Toast.LENGTH_SHORT).show();
            sendUserToBoulderProfile();
        }else {
            Intent galleryIntent = new Intent();
            galleryIntent.setAction(Intent.ACTION_GET_CONTENT);
            galleryIntent.setType("image/*");
            startActivityForResult(galleryIntent, Gallery_Pick);
        }

        BoulderKey = getIntent().getExtras().get("BoulderKey").toString();
        boulderImageStorage = FirebaseStorage.getInstance().getReference();
        storage = FirebaseStorage.getInstance();



        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders").child(BoulderKey);

        img = findViewById(R.id.boulderProfileImage3);
        save = findViewById(R.id.ensureButton);

        save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                loadingBar.setTitle(R.string.ensure_going_loading);
                loadingBar.show();
                loadingBar.setCanceledOnTouchOutside(true);
                StoringImage();
            }
        });


    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data){
        super.onActivityResult(resultCode,resultCode,data);

        if(requestCode==Gallery_Pick && resultCode==RESULT_OK && data!=null){
            ImageUri = data.getData();
            CropImage.activity(ImageUri)
                    .setGuidelines(CropImageView.Guidelines.ON)
                    .setAspectRatio(1, 1)
                    .start(this);

        }

        if(requestCode==CropImage.CROP_IMAGE_ACTIVITY_REQUEST_CODE)
        {
            CropImage.ActivityResult result = CropImage.getActivityResult(data);

            if(resultCode == RESULT_OK)
            {
                ImageUri = result.getUri();

                try {

                    Bitmap bitmap = MediaStore.Images.Media.getBitmap(this.getContentResolver(), ImageUri);
                    int nh = (int) ( bitmap.getHeight() * (512.0 / bitmap.getWidth()) );
                    Bitmap scaled = Bitmap.createScaledBitmap(bitmap, 512, nh, true);
                    String path = MediaStore.Images.Media.insertImage(this.getContentResolver(), scaled, "Title", null);
                    ImageUri = Uri.parse(path);
                    img.setImageURI(ImageUri);


                } catch (IOException e) {
                    e.printStackTrace();
                }

            }
        }

    }

    private void StoringImage() {

        Calendar date = Calendar.getInstance();
        SimpleDateFormat currentDate = new SimpleDateFormat("dd-MM-yyyy");
        saveCurrentDate = currentDate.format(date.getTime());

        Calendar time = Calendar.getInstance();
        SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
        saveCurrentTime = currentTime.format(time.getTime());

        boulderRandomName = saveCurrentDate + saveCurrentTime;

        boulderRandomName = boulderRandomName.replaceAll("\\-", "");

        boulderRandomName = boulderRandomName.replaceAll("\\:", "");
        if(ImageUri==null){

        }else {

            StorageReference filePath1 = boulderImageStorage.child("BoulderImage").child(ImageUri.getLastPathSegment() + boulderRandomName + ".jpg");

            filePath1.putFile(ImageUri).addOnCompleteListener(new OnCompleteListener<UploadTask.TaskSnapshot>() {
                @Override
                public void onComplete(@NonNull Task<UploadTask.TaskSnapshot> task) {
                    if (task.isSuccessful()) {
                        storages = storage.getReferenceFromUrl(task.getResult().getStorage().toString()).toString();
                        downloadURL1 = task.getResult().getDownloadUrl().toString();
                        storeStatus();
                    } else {
                        String message = task.getException().getMessage();
                        Toast.makeText(EnsurePicActivity.this, "Error:" + message, Toast.LENGTH_SHORT).show();
                    }

                }
            });
        }

    }

    private void storeStatus() {
        hashBoulder = new HashMap();
        hashBoulder.put("images", downloadURL1);
        hashBoulder.put("profilestorage", storages);

        BoulderRef.child("BoulderImages").push().updateChildren(hashBoulder).addOnCompleteListener(new OnCompleteListener() {
            @Override
            public void onComplete(@NonNull Task task) {
                if(task.isSuccessful()){
                    sendUserToBoulderProfile();
                    loadingBar.dismiss();
                }else{
                    String message = task.getException().getMessage();
                    Toast.makeText(EnsurePicActivity.this, "Error:" + message, Toast.LENGTH_SHORT).show();
                    loadingBar.dismiss();
                }
            }
        });
    }

    private void sendUserToBoulderProfile() {
        Intent mainIntent = new Intent(EnsurePicActivity.this, BoulderProfileActivity.class);
        mainIntent.putExtra("BoulderKey", BoulderKey);
        startActivity(mainIntent);
        finish();
    }
}
