package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.ContentResolver;
import android.content.Intent;
import android.media.MediaPlayer;
import android.net.Uri;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.MediaController;
import android.widget.Toast;
import android.widget.VideoView;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;

import java.io.File;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;

public class EnsureVideoActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ProgressDialog loadingBar;

    private FirebaseAuth mAuth;

    private MediaController mc;
    private Uri VideoUri;
    private VideoView video;
    private Button save;

    private EditText title, description;

    private StorageReference boulderImageStorage;
    private FirebaseStorage storage;
    private DatabaseReference BoulderRef;
    private HashMap hashBoulder;
    private String  BoulderKey, videos, currentUserID, videoStoreRef, saveCurrentDate, saveCurrentTime, boulderRandomName, downloadURL1;

    private final static int Gallery_Pick_Video = 1;


    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ensure_video);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        boulderImageStorage = FirebaseStorage.getInstance().getReference();
        storage = FirebaseStorage.getInstance();

        Intent galleryIntent = new Intent();
        galleryIntent.setAction(Intent.ACTION_GET_CONTENT);
        galleryIntent.setType("video/*");
        startActivityForResult(galleryIntent, Gallery_Pick_Video);

        loadingBar = new ProgressDialog(this);

        mToolbar = (Toolbar) findViewById(R.id.ensurevideo_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.ensure_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        //videos = getIntent().getExtras().get("video").toString();
        BoulderKey = getIntent().getExtras().get("BoulderKey").toString();
        //VideoUri = (Uri)getIntent().getExtras().get("VideoUri");
        title = findViewById(R.id.video_titles);
        description = findViewById(R.id.video_description);

        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders").child(BoulderKey);




        video = findViewById(R.id.videoView);
        save = findViewById(R.id.save_video);



        save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ValidateInfo();
            }
        });


    }

    private void ValidateInfo() {
        if(title.getText().toString().equals("") || title.getText().toString() == null){
            Toast.makeText(this, R.string.ensurevideo_writeTitle, Toast.LENGTH_SHORT).show();
        }else{
            loadingBar.setTitle("Subiendo video...");
            loadingBar.show();
            loadingBar.setCanceledOnTouchOutside(true);
            storingVideo();
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(resultCode, resultCode, data);
        int dataSize=0;
        if (requestCode == Gallery_Pick_Video && resultCode == RESULT_OK && data != null) {
            VideoUri = data.getData();
            String scheme = VideoUri.getScheme();

            if(scheme.equals(ContentResolver.SCHEME_CONTENT))
            {
                try {
                    InputStream fileInputStream=getApplicationContext().getContentResolver().openInputStream(VideoUri);
                    dataSize = fileInputStream.available();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                System.out.println("File size in bytes"+dataSize);

            }
            else if(scheme.equals(ContentResolver.SCHEME_FILE))
            {
                String path = VideoUri.getPath();
                try {
                   File f = new File(path);
                   dataSize = (int)f.length();
                   System.out.println("File size in bytes"+f.length());
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }

            if(dataSize<=8406364) {
                MediaController mediaController = new MediaController(this);
                mediaController.setAnchorView(video);

                video.setMediaController(mediaController);
                video.setVideoURI(VideoUri);
                video.start();
            }else{

                Toast.makeText(this, "El video que quieres subir es demasiado grande\nPor favor, eliga uno de menor tamaño o baje la resolución al grabar", Toast.LENGTH_LONG).show();
                sendUserToBoulderProfile();
            }

        }
    }

    private void StoringStatus(){
        String videoTitle = title.getText().toString();
        String videoDescription = description.getText().toString();
        hashBoulder = new HashMap();
        hashBoulder.put("videostorage", videoStoreRef);
        hashBoulder.put("video", downloadURL1);
        hashBoulder.put("videoTitle", videoTitle);
        hashBoulder.put("description", videoDescription);
        hashBoulder.put("rate", "0");
        hashBoulder.put("numberOfVots", "0");
        hashBoulder.put("userID", currentUserID);

        BoulderRef.child("BoulderVideos").push().updateChildren(hashBoulder).addOnCompleteListener(new OnCompleteListener() {
            @Override
            public void onComplete(@NonNull Task task) {
                if(task.isSuccessful()) {
                    sendUserToBoulderProfile();
                    loadingBar.dismiss();
                }else{
                    Toast.makeText(EnsureVideoActivity.this, "Error:", Toast.LENGTH_SHORT).show();
                    loadingBar.dismiss();
                }
            }
        });
    }

    private void storingVideo() {
        Calendar date = Calendar.getInstance();
        SimpleDateFormat currentDate = new SimpleDateFormat("dd-MM-yyyy");
        saveCurrentDate = currentDate.format(date.getTime());

        Calendar time = Calendar.getInstance();
        SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
        saveCurrentTime = currentTime.format(time.getTime());

        boulderRandomName = saveCurrentDate + saveCurrentTime;

        boulderRandomName = boulderRandomName.replaceAll("\\-", "");

        boulderRandomName = boulderRandomName.replaceAll("\\:", "");

        if (VideoUri == null) {

        } else {

            StorageReference filePath1 = boulderImageStorage.child("BoulderVideo").child(boulderRandomName + ".mp4");
            filePath1.putFile(VideoUri).addOnCompleteListener(new OnCompleteListener<UploadTask.TaskSnapshot>() {
                @Override
                public void onComplete(@NonNull Task<UploadTask.TaskSnapshot> task) {
                    if (task.isSuccessful()) {
                        videoStoreRef = storage.getReferenceFromUrl(task.getResult().getStorage().toString()).toString();
                        downloadURL1 = task.getResult().getDownloadUrl().toString();
                        StoringStatus();
                    } else {
                        String message = task.getException().getMessage();
                        Toast.makeText(EnsureVideoActivity.this, "Error:" + message, Toast.LENGTH_SHORT).show();
                    }
                }
            });
        }
    }

    private void sendUserToBoulderProfile() {
        Intent mainIntent = new Intent(EnsureVideoActivity.this, BoulderProfileActivity.class);
        mainIntent.putExtra("BoulderKey", BoulderKey);
        startActivity(mainIntent);
        finish();
    }
}
