package com.example.kurama.aprieta;

import android.content.Intent;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageButton;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

public class FindBoulderNotLogedActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ImageButton searchButton;
    private EditText searchText;

    private RecyclerView boulderSearchList;

    private DatabaseReference BoulderRef;
    private String currentUserID, searchBox;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_find_boulder_not_loged);

        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        mToolbar = (Toolbar) findViewById(R.id.notLogedfind_boulders_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setTitle("");

        boulderSearchList = (RecyclerView) findViewById(R.id.notLogedboulders_list);
        boulderSearchList.setHasFixedSize(true);
        boulderSearchList.setLayoutManager(new LinearLayoutManager(this));

        searchButton = (ImageButton) findViewById(R.id.notLogedsearch_boulders_button);
        searchText = (EditText) findViewById(R.id.notLogedsearch_boulders);

        searchAllBoulders("");

        searchButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                searchBox = searchText.getText().toString();
                searchAllBoulders(searchBox);
            }
        });
    }

    private void searchAllBoulders(String searchBox) {
        Query searchBoulders = BoulderRef.orderByChild("name").startAt(searchBox).endAt(searchBox+ "\uf8ff");

        FirebaseRecyclerOptions<FindBoulders> options=new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders,FindBoulders.class).build();
        FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final FindBouldersActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                final String BoulderKey = getRef(position).getKey();
                BoulderRef.child(BoulderKey).addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if (dataSnapshot.exists()) {
                            holder.name.setText(model.getName());
                            holder.location.setText(model.getLocation());
                            holder.grade.setText(model.getGrade());
                            holder.mView.setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View v) {

                                    Intent boulderProfileIntent = new Intent(FindBoulderNotLogedActivity.this, BoulderProfileMapActivity.class);
                                    boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                    startActivity(boulderProfileIntent);
                                    finish();

                                }
                            });
                        } else {
                            holder.linearLayout.removeAllViewsInLayout();
                            holder.linearLayout.setVisibility(View.GONE);
                            holder.Layout_hide();
                        }


                    }
                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });

            }

            @NonNull
            @Override
            public FindBouldersActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout,parent,false);
                FindBouldersActivity.FindBouldersViewHolder viewHolder=new FindBouldersActivity.FindBouldersViewHolder(view);
                return viewHolder;
            }
        };
        boulderSearchList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }
}
