package com.example.kurama.aprieta;

import android.annotation.TargetApi;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.os.Build;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.squareup.picasso.Picasso;

import de.hdodenhof.circleimageview.CircleImageView;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;

public class FindBouldersActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ImageButton searchButton;
    private EditText searchText;

    private FusedLocationProviderClient client;
    private Location l;
    private float[] distance = new float[1];
    Double longitude, latitude;

    private RecyclerView boulderSearchList;
    private RadioButton r1,r2,r3,r4;

    private FirebaseAuth mAuth;
    private DatabaseReference UserRef;
    private DatabaseReference BoulderRef, allBoulderDatabaseRef;
    private String currentUserID, searchBox;
    private int distances=999999999;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
            SendUserTo2MainActivity();
        }else{
            super.onBackPressed();
            finish();
        }

    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_find_boulders);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        allBoulderDatabaseRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");


        mToolbar = (Toolbar) findViewById(R.id.find_boulders_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setTitle("");

        r1 = findViewById(R.id.KM5);
        r2 = findViewById(R.id.KM10);
        r3 = findViewById(R.id.KM15);
        r4 = findViewById(R.id.KM20);

        boulderSearchList = (RecyclerView) findViewById(R.id.boulders_list);
        boulderSearchList.setHasFixedSize(true);
        boulderSearchList.setLayoutManager(new LinearLayoutManager(this));

        searchButton = (ImageButton) findViewById(R.id.search_boulders_button);
        searchText = (EditText) findViewById(R.id.search_boulders);

        searchAllBoulders("");

        searchButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                searchBox = searchText.getText().toString();
                searchAllBoulders(searchBox);
            }
        });

        client = LocationServices.getFusedLocationProviderClient(this);


        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            if(currentUserID.equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
                SendUserTo2MainActivity();

            }else{
                SendUserToMainActivity();
            }
        }
        client.getLastLocation().addOnSuccessListener(this, new OnSuccessListener<Location>() {
            @Override
            public void onSuccess(Location location) {
                if(location==null){
                    Toast.makeText(FindBouldersActivity.this,"Por favor enciende el GPS", Toast.LENGTH_LONG).show();
                }else{
                    System.out.println(location.toString());
                    l = new Location(location);
                    latitude=location.getLatitude();
                    longitude=location.getLongitude();
                }
            }
        });


        r1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(r2.isSelected() || r3.isSelected() || r4.isSelected()){
                    r1.setSelected(false);
                    r1.setChecked(false);
                }else {
                    if (r1.isSelected()) {
                        r1.setSelected(false);
                        r1.setChecked(false);
                        distances = 999999999;
                        searchAllBoulders(searchBox);
                    } else {
                        r1.setSelected(true);
                        r1.setChecked(true);
                        distances = 5;
                        searchAllBoulders(searchBox);
                    }
                }
            }
        });



        r2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(r1.isSelected() || r3.isSelected() || r4.isSelected()){
                    r2.setSelected(false);
                    r2.setChecked(false);
                }else {
                    if (r2.isSelected()) {
                        r2.setSelected(false);
                        r2.setChecked(false);
                        distances = 999999999;
                        searchAllBoulders(searchBox);
                    } else {
                        r2.setSelected(true);
                        r2.setChecked(true);
                        distances = 10;
                        searchAllBoulders(searchBox);
                    }
                }
            }
        });

        r3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(r1.isSelected() || r2.isSelected() || r4.isSelected()){
                    r3.setSelected(false);
                    r3.setChecked(false);
                }else {
                    if (r3.isSelected()) {
                        r3.setSelected(false);
                        r3.setChecked(false);
                        distances = 999999999;
                        searchAllBoulders(searchBox);
                    } else {
                        r3.setSelected(true);
                        r3.setChecked(true);
                        distances = 15;
                        searchAllBoulders(searchBox);
                    }
                }
            }
        });

        r4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(r1.isSelected() || r2.isSelected() || r3.isSelected()){
                    r4.setSelected(false);
                    r4.setChecked(false);
                }else {
                    if (r4.isSelected()) {
                        r4.setSelected(false);
                        r4.setChecked(false);
                        distances = 999999999;
                        searchAllBoulders(searchBox);
                    } else {
                        r4.setSelected(true);
                        r4.setChecked(true);
                        distances = 20;
                        searchAllBoulders(searchBox);
                    }
                }
            }
        });




    }

    private void searchAllBoulders(String searchBox) {
        Query searchBoulders = allBoulderDatabaseRef.orderByChild("name").startAt(searchBox).endAt(searchBox+ "\uf8ff");

        FirebaseRecyclerOptions<FindBoulders> options=new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders,FindBoulders.class).build();
        FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final FindBouldersActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                final String BoulderKey = getRef(position).getKey();
                BoulderRef.child(BoulderKey).addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if (dataSnapshot.exists()) {
                            if(latitude.equals(null) || longitude.equals(null) || dataSnapshot.child("latitude").getValue().toString().equals(null) || dataSnapshot.child("longitude").getValue().toString().equals(null)){
                                SendUserToSefActivity();
                            }
                                l.distanceBetween(latitude, longitude, Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()), Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()),
                                        distance = new float[1]);

                                System.out.println("DISTANCE: " + distance[0]);
                                System.out.println("ACTUAL LOCATION: " + latitude + " " + longitude);
                                System.out.println("STORED LOCATION: " + Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()) + " " + Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()));
                                if((distance[0]/1000)<distances){
                                    holder.name.setText(model.getName());
                                    holder.location.setText(model.getLocation());
                                    holder.grade.setText(model.getGrade());
                                    holder.mView.setOnClickListener(new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {

                                            Intent boulderProfileIntent = new Intent(FindBouldersActivity.this, BoulderProfileActivity.class);
                                            boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                            startActivity(boulderProfileIntent);
                                            finish();

                                        }
                                    });
                                }else{
                                    holder.linearLayout.removeAllViewsInLayout();
                                    holder.linearLayout.setVisibility(View.GONE);
                                    holder.Layout_hide();
                                }


                        }
                    }
                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });

            }

            @NonNull
            @Override
            public FindBouldersActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout,parent,false);
                FindBouldersActivity.FindBouldersViewHolder viewHolder=new FindBouldersActivity.FindBouldersViewHolder(view);
                return viewHolder;
            }
        };
        boulderSearchList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }

    private void SendUserToSefActivity() {
        Intent selfIntent = new Intent(FindBouldersActivity.this, FindBouldersActivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserToMainActivity() {
        Intent selfIntent = new Intent(FindBouldersActivity.this, MainActivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserTo2MainActivity() {
        Intent mainIntent = new Intent(FindBouldersActivity.this, Main2Activity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }

    public static class FindBouldersViewHolder extends RecyclerView.ViewHolder{
        RelativeLayout.LayoutParams params;
        LinearLayout linearLayout;
        RelativeLayout size;
        TextView name, location, grade;
        View mView;
        public FindBouldersViewHolder(View itemView) {
            super(itemView);
            mView = itemView;
            params = new RelativeLayout.LayoutParams(0, 0);
            linearLayout = (LinearLayout) mView.findViewById(R.id.boulderList);
            name=mView.findViewById(R.id.all_boulder_name);
            size=mView.findViewById(R.id.size);
            location=mView.findViewById(R.id.all_boulder_location);
            grade=mView.findViewById(R.id.all_grade);
        }

        public void Layout_hide() {
            params.height = 0;
            //itemView.setLayoutParams(params);
            linearLayout.setLayoutParams(params);
        }
        public void Layout_show() {
            params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            //itemView.setLayoutParams(params);
            linearLayout.setLayoutParams(params);
        }
    }

}
