package com.example.kurama.aprieta;

import android.content.Intent;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;


import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.squareup.picasso.Picasso;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import de.hdodenhof.circleimageview.CircleImageView;

public class FriendRequestsActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private SwipeRefreshLayout sw;

    private RecyclerView requestList;

    private FirebaseAuth mAuth;
    private DatabaseReference FriendsRef, FriendRequestRef;
    private DatabaseReference ReceivedRef, allUserDatabaseRef;
    private String currentUserID, CURRENT_STATE="", saveCurrentDate, otherID;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_friend_requests);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        allUserDatabaseRef = FirebaseDatabase.getInstance().getReference().child("Users");
        FriendRequestRef = FirebaseDatabase.getInstance().getReference().child("FriendRequest");
        ReceivedRef = FirebaseDatabase.getInstance().getReference().child("FriendRequest").child(currentUserID);
        FriendsRef = FirebaseDatabase.getInstance().getReference().child("Users");

        mToolbar = (Toolbar) findViewById(R.id.friend_request_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.friend_request_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        requestList = (RecyclerView) findViewById(R.id.users_request_list);
        requestList.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        requestList.setLayoutManager(linearLayoutManager);
        sw = findViewById(R.id.swipeRequest);
        searchRequest();

        requestList.setVisibility(View.INVISIBLE);

        sw.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                searchRequest();
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        sw.setRefreshing(false);
                    }
                },1000);
            }
        });
    }


    private void searchRequest() {

         Query searchPeople = allUserDatabaseRef.orderByChild("fullname");


        FirebaseRecyclerOptions<FindFriends> options=new FirebaseRecyclerOptions.Builder<FindFriends>().setQuery(searchPeople,FindFriends.class).build();
        FirebaseRecyclerAdapter<FindFriends, FriendRequestsActivity.RequestsViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindFriends, FriendRequestsActivity.RequestsViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final FriendRequestsActivity.RequestsViewHolder holder, int position, @NonNull final FindFriends model) {
                final String ProfileKey = getRef(position).getKey();
               ReceivedRef.child(ProfileKey).addListenerForSingleValueEvent(new ValueEventListener() {
                    @Override
                    public void onDataChange(final DataSnapshot dataSnapshot) {
                        if (dataSnapshot.exists()) {
                            if (dataSnapshot.child("request_type").getValue().toString().equals("received")) {
                                requestList.setVisibility(View.VISIBLE);
                                holder.username.setText(model.getUsername());
                                holder.fullname.setText(model.getFullname());
                                Picasso.get().load(model.getProfileimage()).into(holder.user_profile_image);
                                holder.mView.setOnClickListener(new View.OnClickListener() {
                                    @Override
                                    public void onClick(View v) {

                                        if(currentUserID.equals(ProfileKey)){
                                            SendUserToProfileAcitivity();
                                        }else{
                                            Intent clickProfileIntent = new Intent(FriendRequestsActivity.this, PersonProfileActivity.class);
                                            clickProfileIntent.putExtra("ProfileKey", ProfileKey);
                                            startActivity(clickProfileIntent);
                                        }


                                    }
                                });

                                holder.addButton.setOnClickListener(new View.OnClickListener() {
                                    @Override
                                    public void onClick(View v) {
                                        Calendar date = Calendar.getInstance();
                                        SimpleDateFormat currentDate = new SimpleDateFormat("dd-MM-yyyy");
                                        saveCurrentDate = currentDate.format(date.getTime());
                                        FriendsRef.child(currentUserID).child("Friends").child(ProfileKey).child("date").setValue(saveCurrentDate);
                                        FriendsRef.child(currentUserID).child("Friends").child(ProfileKey).child("chat").setValue("false");
                                        FriendsRef.child(ProfileKey).child("Friends").child(currentUserID).child("chat").setValue("false");

                                        FriendsRef.child(ProfileKey).child("Friends").child(currentUserID).child("date").setValue(saveCurrentDate).addOnCompleteListener(new OnCompleteListener<Void>() {
                                            @Override
                                            public void onComplete(@NonNull Task<Void> task) {
                                                if(task.isSuccessful()){
                                                    Toast.makeText(FriendRequestsActivity.this,R.string.friend_added_noty, Toast.LENGTH_SHORT).show();
                                                    FriendRequestRef.child(currentUserID).child(ProfileKey).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                                        @Override
                                                        public void onComplete(@NonNull Task<Void> task) {
                                                            if(task.isSuccessful()){

                                                                FriendRequestRef.child(ProfileKey).child(currentUserID).removeValue();
                                                                searchRequest();
                                                            }
                                                        }
                                                    });
                                                }
                                            }
                                        });
                                    }
                                });

                                holder.cancelButton.setOnClickListener(new View.OnClickListener() {
                                    @Override
                                    public void onClick(View v) {
                                        FriendRequestRef.child(currentUserID).child(ProfileKey).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                            @Override
                                            public void onComplete(@NonNull Task<Void> task) {
                                                if(task.isSuccessful()){

                                                    FriendRequestRef.child(ProfileKey).child(currentUserID).removeValue();
                                                    searchRequest();
                                                }
                                            }
                                        });
                                    }
                                });
                            }else{
                                holder.linearLayout.removeAllViewsInLayout();
                                holder.linearLayout.setVisibility(View.GONE);
                                holder.Layout_hide();
                            }
                        }else{
                            holder.linearLayout.removeAllViewsInLayout();
                            holder.linearLayout.setVisibility(View.GONE);
                            holder.Layout_hide();

                        }
                    }

                    @Override
                   public void onCancelled(DatabaseError databaseError) {

                    }
               });


            }

            @NonNull
            @Override
            public FriendRequestsActivity.RequestsViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.user_request_list_layout,parent,false);
                FriendRequestsActivity.RequestsViewHolder viewHolder=new FriendRequestsActivity.RequestsViewHolder(view);
                return viewHolder;
            }
        };
        requestList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();
    }


    private void SendUserToSameActivity() {
        Intent mainIntent = new Intent(FriendRequestsActivity.this, FriendRequestsActivity.class);
        startActivity(mainIntent);
        finish();
    }


    private void SendUserToProfileAcitivity() {
        Intent profileIntent = new Intent(FriendRequestsActivity.this, ProfileActivity.class);
        startActivity(profileIntent);
        finish();
    }

    public class RequestsViewHolder extends RecyclerView.ViewHolder{
        RelativeLayout.LayoutParams params;
        LinearLayout linearLayout;
        TextView fullname,username;
        CircleImageView user_profile_image;
        ImageButton addButton, cancelButton;
        View mView;
        public RequestsViewHolder(View itemView) {
            super(itemView);
            mView = itemView;
            linearLayout = (LinearLayout) mView.findViewById(R.id.linearRequest);
            params = new RelativeLayout.LayoutParams(0, 0);
            username=mView.findViewById(R.id.all_users_request_username);
            fullname=mView.findViewById(R.id.all_users_request_name);
            user_profile_image=mView.findViewById(R.id.all_users_request_image);
            addButton = mView.findViewById(R.id.reques_answer);
            cancelButton = mView.findViewById(R.id.cancelRequest);


        }

        void Layout_hide() {
            linearLayout.setVisibility(View.GONE);
            params.height = 0;
            params.width = 0;
            //itemView.setLayoutParams(params);
            linearLayout.setLayoutParams(params);

        }
    }
}
