package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.Intent;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;

import org.w3c.dom.Text;

public class LoginActivity extends AppCompatActivity {

    private Button LoginButton, notLogedActions;
    private EditText UserEmail, UserPassword;
    private TextView UserRegister, ForgetPassword;
    private ProgressDialog loadingBar;

    private FirebaseAuth mAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        mAuth = FirebaseAuth.getInstance();

        UserRegister = (TextView) findViewById(R.id.userregister);
        UserEmail = (EditText) findViewById(R.id.login_email);
        UserPassword = (EditText) findViewById(R.id.login_password);
        LoginButton = (Button) findViewById(R.id.login);
        ForgetPassword = (TextView) findViewById(R.id.forget_password);
        notLogedActions = findViewById(R.id.notLogedActions);
        loadingBar = new ProgressDialog(this);

        notLogedActions.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToNotLogedActivity();
            }
        });

        UserRegister.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToRegisterActivity();
            }
        });

        LoginButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AllowUser();
            }
        });

        ForgetPassword.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToResetPasswordActivity();
            }
        });
    }



    @Override
    protected void onStart() {
        super.onStart();

        FirebaseUser currentUser = mAuth.getCurrentUser();

        if(currentUser!=null && currentUser.getUid().equals("LiApsI6W5uVfOFBZdyqgRBpL9li1")){
            SendUserToAdminMainActivity();
        }else if(currentUser!=null){
            SendUserToMainActivity();
        }

    }

    private void AllowUser() {
        final String email = UserEmail.getText().toString();
        String password = UserPassword.getText().toString();

        if(TextUtils.isEmpty(email)){
            Toast.makeText(this, R.string.login_email_noty, Toast.LENGTH_SHORT).show();
        }else if (TextUtils.isEmpty(password)){
            Toast.makeText(this, R.string.login_password_noty, Toast.LENGTH_SHORT).show();
        }else{
            loadingBar.setTitle(R.string.login_loadding);;
            loadingBar.show();
            loadingBar.setCanceledOnTouchOutside(true);
            mAuth.signInWithEmailAndPassword(email, password).addOnCompleteListener(new OnCompleteListener<AuthResult>() {
                @Override
                public void onComplete(@NonNull Task<AuthResult> task) {
                    if(task.isSuccessful()){
                        if(email.equals("aprietaadmins@gmail.com")){
                            loadingBar.dismiss();
                            SendUserToAdminMainActivity();
                            Toast.makeText(LoginActivity.this, R.string.login_success_noty, Toast.LENGTH_SHORT).show();
                        }else {
                            loadingBar.dismiss();
                            SendUserToMainActivity();
                            Toast.makeText(LoginActivity.this, R.string.login_success_noty, Toast.LENGTH_SHORT).show();
                        }

                    }else{
                        String message = task.getException().getMessage();
                        Toast.makeText(LoginActivity.this, "Erro:"+message, Toast.LENGTH_SHORT).show();
                        loadingBar.dismiss();
                    }
                }
            });
        }

    }

    private void SendUserToMainActivity() {
        Intent mainIntent = new Intent(LoginActivity.this, MainActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }

    private void SendUserToAdminMainActivity() {
        Intent mainIntent = new Intent(LoginActivity.this, Main2Activity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }

    private void SendUserToNotLogedActivity(){
        Intent registerIntent = new Intent(LoginActivity.this, NotLogedActivity.class);
        startActivity(registerIntent);
    }

    private void SendUserToRegisterActivity(){
        Intent registerIntent = new Intent(LoginActivity.this, RegisterActivity.class);
        startActivity(registerIntent);
        
    }

    private void SendUserToResetPasswordActivity() {
        Intent resetPassIntent = new Intent(LoginActivity.this, ResetPasswordActivity.class);
        startActivity(resetPassIntent);
    }
}
