package com.example.kurama.aprieta;

import android.content.Intent;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageButton;

import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;

public class Main2Activity extends AppCompatActivity {

    private ImageButton adminUsers, adminBoulders, adminMessages, logOutAdmin;
    FirebaseAuth mAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main2);
        requestPermission();

        mAuth = FirebaseAuth.getInstance();

        adminUsers = findViewById(R.id.adminUsers);
        adminBoulders = findViewById(R.id.adminBoulders);
        adminMessages = findViewById(R.id.adminMessages);
        logOutAdmin = findViewById(R.id.logOutAdmin);


        adminUsers.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFindUserActivity();
            }
        });

        adminBoulders.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFindBoulderActivity();
            }
        });

        adminMessages.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToMessageActivity();
            }
        });

        logOutAdmin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mAuth.signOut();
                SendUserToLoginActivity();
            }
        });
    }

    @Override
    protected void onStart() {
        super.onStart();
        String currentUser = mAuth.getUid();
        if(currentUser == null || currentUser.equals("")) {
            SendUserToLoginActivity();
        }
    }

    private void requestPermission(){
        ActivityCompat.requestPermissions(this, new String[]{ACCESS_FINE_LOCATION},1);
    }

    private  void SendUserToLoginActivity() {
        Intent loginIntent = new Intent(Main2Activity.this, LoginActivity.class);
        loginIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(loginIntent);
        finish();
    }

    private void SendUserToFindUserActivity() {
        Intent mainIntent = new Intent(Main2Activity.this, FindUsersActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
    }

    private void SendUserToFindBoulderActivity() {
        Intent mainIntent = new Intent(Main2Activity.this, FindBouldersActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
    }

    private void SendUserToMessageActivity() {
        Intent mainIntent = new Intent(Main2Activity.this, ChatAdminActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
    }
}
