package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.location.Location;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.HashMap;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;

public class ManualChallengeActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ProgressDialog loadingBar;

    private DatabaseReference BoulderRef, ChallengeRef, UserRef;
    private FirebaseAuth mAuth;

    private FusedLocationProviderClient client;
    private Location l;
    private float[] distance = new float[1];
    Double longitude, latitude;

    private RecyclerView boulderSearchList;
    private Spinner distanceBox, difficultyBox;
    private String grade, distancess,currentUserID, profileimage, username, BoulderKey, searchBox;
    private Button saveButton;
    private EditText searchBoulderInput;
    private ImageButton searchButton, addChallengeButton;
    private int distances=0;
    private ArrayList<String> BoulderKeys = new ArrayList<>();

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_manual_challenge);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users").child(currentUserID);
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        ChallengeRef = FirebaseDatabase.getInstance().getReference().child("Challenges");

        loadingBar = new ProgressDialog(this);

        mToolbar =  findViewById(R.id.manualChallenge_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.manualchallenge_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        distanceBox = findViewById(R.id.distanceBox2);
        difficultyBox = findViewById(R.id.difficultyBox2);
        saveButton = findViewById(R.id.saveSmartChallenge);
        searchButton = findViewById(R.id.search_boulder_challenge_button);
        searchBoulderInput = findViewById(R.id.searchBoulder_Challenge);
        addChallengeButton = findViewById(R.id.addChallengeManualButton);

        boulderSearchList = (RecyclerView) findViewById(R.id.challengeBoulder_list);
        boulderSearchList.setHasFixedSize(true);
        boulderSearchList.setLayoutManager(new LinearLayoutManager(this));

        client = LocationServices.getFusedLocationProviderClient(this);

        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            SendUserToMainActivity();
        }
        client.getLastLocation().addOnSuccessListener(this, new OnSuccessListener<Location>() {
            @Override
            public void onSuccess(Location location) {
                if(location==null){
                    Toast.makeText(ManualChallengeActivity.this,"Por favor enciende el GPS", Toast.LENGTH_LONG).show();
                }else{
                    System.out.println(location.toString());
                    l = new Location(location);
                    latitude=location.getLatitude();
                    longitude=location.getLongitude();
                }
            }
        });

        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, R.array.distances, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        distanceBox.setAdapter(adapter);
        distanceBox.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                distancess = parent.getItemAtPosition(position).toString();
                if(distancess.equals("5Km")){
                    distances = 5;
                }else if(distancess.equals("10Km")){
                    distances = 10;
                }else if(distancess.equals("15Km")){
                    distances = 15;
                }else if(distancess.equals("20Km")){
                    distances = 20;
                }else if(distancess.equals("25Km")){
                    distances = 25;
                }else if(distancess.equals("30Km")){
                    distances = 30;
                }else if(distancess.equals("35Km")){
                    distances = 35;
                }else if(distancess.equals("40Km")){
                    distances = 40;
                }else if(distancess.equals("45Km")){
                    distances = 45;
                }else if(distancess.equals("50Km")){
                    distances = 50;
                }

            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });

        ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(this, R.array.difficulty, android.R.layout.simple_spinner_item);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        difficultyBox.setAdapter(adapter2);
        difficultyBox.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                grade = parent.getItemAtPosition(position).toString();

            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });

        UserRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){
                    username = dataSnapshot.child("username").getValue().toString();
                    profileimage = dataSnapshot.child("profileimage").getValue().toString();
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        searchButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                searchBox = searchBoulderInput.getText().toString();
                searchBoulders(searchBox);
            }
        });

        addChallengeButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!BoulderKeys.isEmpty()) {
                    final HashMap challengeHash = new HashMap();
                    final HashMap boulderHash = new HashMap();
                    final HashMap participantHash = new HashMap();
                    final String challengeKey = ChallengeRef.push().getKey();

                    for (int i = 0; i < BoulderKeys.size(); i++) {
                        final int finalI = i;
                        BoulderRef.child(BoulderKeys.get(i)).addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {

                                System.out.println("BOULDER KEY: "+ BoulderKeys.get(finalI));

                                challengeHash.put("difficulty", grade);
                                challengeHash.put("distance", distances);
                                challengeHash.put("numberOfVots", "0");
                                challengeHash.put("rate", "0");
                                challengeHash.put("userID", currentUserID);
                                challengeHash.put("username", username);
                                challengeHash.put("profileimage", profileimage);

                                boulderHash.put("name", dataSnapshot.child("name").getValue().toString());
                                boulderHash.put("location", dataSnapshot.child("location").getValue().toString());
                                boulderHash.put("grade", dataSnapshot.child("grade").getValue().toString());

                                participantHash.put("bouldersDone", "0");


                                ChallengeRef.child(challengeKey).updateChildren(challengeHash);
                                ChallengeRef.child(challengeKey).child("Boulders").child(BoulderKeys.get(finalI)).updateChildren(boulderHash);
                                ChallengeRef.child(challengeKey).child("Participants").child(currentUserID).updateChildren(participantHash);
                                UserRef.child("OwnChallenges").child(challengeKey).updateChildren(challengeHash);
                                UserRef.child("OwnChallenges").child(challengeKey).child("Boulders").child(BoulderKeys.get(finalI)).updateChildren(boulderHash);
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });


                    }
                    Toast.makeText(ManualChallengeActivity.this,R.string.challenge_created, Toast.LENGTH_LONG).show();
                    SendUserToAllChallengeListAcitivty();


                }else{
                    Toast.makeText(ManualChallengeActivity.this, R.string.manualchallenge_chooseOne, Toast.LENGTH_LONG).show();
                }
            }
        });
    }

    private void searchBoulders(String searchBox) {
        Query searchBoulders = BoulderRef.orderByChild("name").startAt(searchBox).endAt(searchBox+ "\uf8ff");
        if(grade.equals("Facil")) {
            FirebaseRecyclerOptions<FindBoulders> options = new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders, FindBoulders.class).build();
            FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder>(options) {
                @Override
                protected void onBindViewHolder(@NonNull final FindBouldersActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                    final String BoulderKey = getRef(position).getKey();
                    BoulderRef.child(BoulderKey).addListenerForSingleValueEvent(new ValueEventListener() {
                        @Override
                        public void onDataChange(DataSnapshot dataSnapshot) {
                            if (dataSnapshot.exists()) {
                                if (latitude.equals(null) || longitude.equals(null) || dataSnapshot.child("latitude").getValue().toString().equals(null) || dataSnapshot.child("longitude").getValue().toString().equals(null)) {
                                    SendUserToSefActivity();
                                }
                                l.distanceBetween(latitude, longitude, Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()), Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()),
                                        distance = new float[1]);

                                System.out.println("DISTANCE: " + distance[0]);
                                System.out.println("ACTUAL LOCATION: " + latitude + " " + longitude);
                                System.out.println("STORED LOCATION: " + Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()) + " " + Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()));
                                if ((distance[0] / 1000) < distances && (dataSnapshot.child("grade").getValue().toString().equals("4") || dataSnapshot.child("grade").getValue().toString().equals("5A") || dataSnapshot.child("grade").getValue().toString().equals("5A+") ||
                                        dataSnapshot.child("grade").getValue().toString().equals("5B") || dataSnapshot.child("grade").getValue().toString().equals("5B+") || dataSnapshot.child("grade").getValue().toString().equals("5C") || dataSnapshot.child("grade").getValue().toString().equals("5C+") || dataSnapshot.child("grade").getValue().toString().equals("6A"))) {
                                    holder.name.setText(model.getName());
                                    holder.location.setText(model.getLocation());
                                    holder.grade.setText(model.getGrade());
                                    holder.mView.setOnClickListener(new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {

                                            Intent boulderProfileIntent = new Intent(ManualChallengeActivity.this, BoulderProfileActivity.class);
                                            boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                            startActivity(boulderProfileIntent);
                                            finish();

                                        }
                                    });

                                    holder.mView.setOnLongClickListener(new View.OnLongClickListener() {
                                        @Override
                                        public boolean onLongClick(View v) {
                                            holder.size.setBackgroundColor(Color.rgb(192,216,144));
                                            BoulderKeys.add(BoulderKey);
                                            return true;
                                        }
                                    });
                                } else {
                                    holder.linearLayout.removeAllViewsInLayout();
                                    holder.linearLayout.setVisibility(View.GONE);
                                    holder.Layout_hide();
                                }


                            }
                        }

                        @Override
                        public void onCancelled(DatabaseError databaseError) {

                        }
                    });

                }

                @NonNull
                @Override
                public FindBouldersActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                    View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout, parent, false);
                    FindBouldersActivity.FindBouldersViewHolder viewHolder = new FindBouldersActivity.FindBouldersViewHolder(view);
                    return viewHolder;
                }
            };
            boulderSearchList.setAdapter(firebaseRecyclerAdapter);
            firebaseRecyclerAdapter.startListening();

        }else if(grade.equals("Medio")) {
            FirebaseRecyclerOptions<FindBoulders> options = new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders, FindBoulders.class).build();
            FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder>(options) {
                @Override
                protected void onBindViewHolder(@NonNull final FindBouldersActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                    final String BoulderKey = getRef(position).getKey();
                    BoulderRef.child(BoulderKey).addListenerForSingleValueEvent(new ValueEventListener() {
                        @Override
                        public void onDataChange(DataSnapshot dataSnapshot) {
                            if (dataSnapshot.exists()) {
                                if (latitude.equals(null) || longitude.equals(null) || dataSnapshot.child("latitude").getValue().toString().equals(null) || dataSnapshot.child("longitude").getValue().toString().equals(null)) {
                                    SendUserToSefActivity();
                                }
                                l.distanceBetween(latitude, longitude, Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()), Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()),
                                        distance = new float[1]);

                                System.out.println("DISTANCE: " + distance[0]);
                                System.out.println("ACTUAL LOCATION: " + latitude + " " + longitude);
                                System.out.println("STORED LOCATION: " + Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()) + " " + Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()));
                                if ((distance[0] / 1000) < distances && (dataSnapshot.child("grade").getValue().toString().equals("6A+") || dataSnapshot.child("grade").getValue().toString().equals("6B") || dataSnapshot.child("grade").getValue().toString().equals("6B+") ||
                                        dataSnapshot.child("grade").getValue().toString().equals("6C") || dataSnapshot.child("grade").getValue().toString().equals("6C+") || dataSnapshot.child("grade").getValue().toString().equals("7A") || dataSnapshot.child("grade").getValue().toString().equals("7A+") || dataSnapshot.child("grade").getValue().toString().equals("7B") || dataSnapshot.child("grade").getValue().toString().equals("7B+"))){
                                    holder.name.setText(model.getName());
                                    holder.location.setText(model.getLocation());
                                    holder.grade.setText(model.getGrade());
                                    holder.mView.setOnClickListener(new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {

                                            Intent boulderProfileIntent = new Intent(ManualChallengeActivity.this, BoulderProfileActivity.class);
                                            boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                            startActivity(boulderProfileIntent);
                                            finish();

                                        }
                                    });
                                    holder.mView.setOnLongClickListener(new View.OnLongClickListener() {
                                        @Override
                                        public boolean onLongClick(View v) {
                                            holder.size.setBackgroundColor(Color.rgb(192,216,144));
                                            BoulderKeys.add(BoulderKey);
                                            return true;
                                        }
                                    });
                                } else {
                                    holder.linearLayout.removeAllViewsInLayout();
                                    holder.linearLayout.setVisibility(View.GONE);
                                    holder.Layout_hide();
                                }


                            }
                        }

                        @Override
                        public void onCancelled(DatabaseError databaseError) {

                        }
                    });

                }

                @NonNull
                @Override
                public FindBouldersActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                    View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout, parent, false);
                    FindBouldersActivity.FindBouldersViewHolder viewHolder = new FindBouldersActivity.FindBouldersViewHolder(view);
                    return viewHolder;
                }
            };
            boulderSearchList.setAdapter(firebaseRecyclerAdapter);
            firebaseRecyclerAdapter.startListening();
        }else if(grade.equals("Dificil")) {
            FirebaseRecyclerOptions<FindBoulders> options = new FirebaseRecyclerOptions.Builder<FindBoulders>().setQuery(searchBoulders, FindBoulders.class).build();
            FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder> firebaseRecyclerAdapter = new FirebaseRecyclerAdapter<FindBoulders, FindBouldersActivity.FindBouldersViewHolder>(options) {
                @Override
                protected void onBindViewHolder(@NonNull final FindBouldersActivity.FindBouldersViewHolder holder, int position, @NonNull final FindBoulders model) {
                    final String BoulderKey = getRef(position).getKey();
                    BoulderRef.child(BoulderKey).addListenerForSingleValueEvent(new ValueEventListener() {
                        @Override
                        public void onDataChange(DataSnapshot dataSnapshot) {
                            if (dataSnapshot.exists()) {
                                if (latitude.equals(null) || longitude.equals(null) || dataSnapshot.child("latitude").getValue().toString().equals(null) || dataSnapshot.child("longitude").getValue().toString().equals(null)) {
                                    SendUserToSefActivity();
                                }
                                l.distanceBetween(latitude, longitude, Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()), Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()),
                                        distance = new float[1]);

                                System.out.println("DISTANCE: " + distance[0]);
                                System.out.println("ACTUAL LOCATION: " + latitude + " " + longitude);
                                System.out.println("STORED LOCATION: " + Double.parseDouble(dataSnapshot.child("latitude").getValue().toString()) + " " + Double.parseDouble(dataSnapshot.child("longitude").getValue().toString()));
                                if ((distance[0] / 1000) < distances && (dataSnapshot.child("grade").getValue().toString().equals("7C") || dataSnapshot.child("grade").getValue().toString().equals("7C+") || dataSnapshot.child("grade").getValue().toString().equals("8A") ||
                                        dataSnapshot.child("grade").getValue().toString().equals("8A+") || dataSnapshot.child("grade").getValue().toString().equals("8B") || dataSnapshot.child("grade").getValue().toString().equals("8B+") || dataSnapshot.child("grade").getValue().toString().equals("8C") || dataSnapshot.child("grade").getValue().toString().equals("8C+"))){
                                    holder.name.setText(model.getName());
                                    holder.location.setText(model.getLocation());
                                    holder.grade.setText(model.getGrade());
                                    holder.mView.setOnClickListener(new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {

                                            Intent boulderProfileIntent = new Intent(ManualChallengeActivity.this, BoulderProfileActivity.class);
                                            boulderProfileIntent.putExtra("BoulderKey", BoulderKey);
                                            startActivity(boulderProfileIntent);
                                            finish();

                                        }
                                    });
                                    holder.mView.setOnLongClickListener(new View.OnLongClickListener() {
                                        @Override
                                        public boolean onLongClick(View v) {
                                            holder.size.setBackgroundColor(Color.rgb(192,216,144));
                                            BoulderKeys.add(BoulderKey);
                                            return true;
                                        }
                                    });
                                } else {
                                    holder.linearLayout.removeAllViewsInLayout();
                                    holder.linearLayout.setVisibility(View.GONE);
                                    holder.Layout_hide();
                                }


                            }
                        }

                        @Override
                        public void onCancelled(DatabaseError databaseError) {

                        }
                    });

                }

                @NonNull
                @Override
                public FindBouldersActivity.FindBouldersViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                    View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.all_boulder_display_layout, parent, false);
                    FindBouldersActivity.FindBouldersViewHolder viewHolder = new FindBouldersActivity.FindBouldersViewHolder(view);
                    return viewHolder;
                }
            };
            boulderSearchList.setAdapter(firebaseRecyclerAdapter);
            firebaseRecyclerAdapter.startListening();
        }

    }



    private void SendUserToAllChallengeListAcitivty() {
        Intent selfIntent = new Intent(ManualChallengeActivity.this, AllChallengeListActivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserToSefActivity() {
        Intent selfIntent = new Intent(ManualChallengeActivity.this, FindBouldersActivity.class);
        startActivity(selfIntent);
        finish();
    }
    private void SendUserToMainActivity() {
        Intent selfIntent = new Intent(ManualChallengeActivity.this, MainActivity.class);
        startActivity(selfIntent);
        finish();
    }
}
