package com.example.kurama.aprieta;

import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.ImageButton;
import android.widget.TextView;

import com.google.android.gms.location.FusedLocationProviderClient;

public class NotLogedActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private FusedLocationProviderClient client;

    TextView currentLocal, mapLocal;
    ImageButton imgcurrentLocal, imgmapLocal;
    Double longitude, latitude;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_not_loged);

        mToolbar = (Toolbar) findViewById(R.id.choose_boulder_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.add_boulder_option_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        currentLocal = findViewById(R.id.notLogedBoulderSearch);
        mapLocal = findViewById(R.id.mapSearchNotLoged);
        imgcurrentLocal = findViewById(R.id.imagenotLogedBoulderSearch);
        imgmapLocal = findViewById(R.id.imagemapSearchNotLoged);

        currentLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgcurrentLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToSearchBoulderActivity();
            }
        });

        imgcurrentLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgcurrentLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToSearchBoulderActivity();
            }
        });

        mapLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgmapLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToMapActivity();
            }
        });

        imgmapLocal.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgmapLocal.setColorFilter(Color.WHITE, android.graphics.PorterDuff.Mode.MULTIPLY);
                SendUserToMapActivity();
            }
        });
    }

    private void SendUserToSearchBoulderActivity() {
        Intent mapIntent = new Intent(NotLogedActivity.this, FindBoulderNotLogedActivity.class);
        startActivity(mapIntent);
        finish();
    }

    private void SendUserToMapActivity() {
        Intent mapIntent = new Intent(NotLogedActivity.this, MapNotLogedActivity.class);
        startActivity(mapIntent);
        finish();
    }
}
