package com.example.kurama.aprieta;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.ContextWrapper;
import android.content.Intent;
import android.graphics.Color;
import android.os.Build;
import android.support.v4.app.NotificationCompat;

public class NotificationHelper extends ContextWrapper {
    public static final String channel1ID = "channel1ID", channel1Name = "Channel1", channel2ID = "channel2ID", channel2Name = "Channel2";
    private NotificationManager mManager;
    public NotificationHelper(Context base) {
        super(base);
        createChannels();

    }

    public void createChannels() {
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.O) {
            NotificationChannel channel = new NotificationChannel(channel1ID, channel1Name, NotificationManager.IMPORTANCE_DEFAULT);
            channel.enableLights(true);
            channel.enableVibration(true);
            channel.setLightColor(R.color.colorPrimary);
            channel.setLockscreenVisibility(Notification.VISIBILITY_PRIVATE);

            getManager().createNotificationChannel(channel);

            NotificationChannel channe2 = new NotificationChannel(channel2ID, channel2Name, NotificationManager.IMPORTANCE_DEFAULT);
            channel.enableLights(true);
            channel.enableVibration(true);
            channel.setLightColor(R.color.colorPrimary);
            channel.setLockscreenVisibility(Notification.VISIBILITY_PRIVATE);

            getManager().createNotificationChannel(channe2);

        }
    }

    public NotificationManager getManager(){
        if(mManager == null){
            mManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        }
        return mManager;
    }

    public NotificationCompat.Builder getChannel1Notification(){
        Intent resultIntent = new Intent(this, FriendRequestsActivity.class);
        PendingIntent resultPendingIntent = PendingIntent.getActivity(this, 1, resultIntent, PendingIntent.FLAG_UPDATE_CURRENT);


        return new NotificationCompat.Builder(getApplicationContext(), channel1ID)
                .setContentTitle("Aprieta")
                .setContentText("Lagun eskaera berria")
                .setSmallIcon(R.drawable.logo1)
                .setColor(Color.WHITE)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT)
                .setLights(Color.RED, 1000, 1000)
                .setVibrate(new long[]{1000,1000})
                .setDefaults(Notification.DEFAULT_SOUND)
                .setContentIntent(resultPendingIntent)
                .setAutoCancel(true);
    }
    public NotificationCompat.Builder getChanne21Notification(){
        return new NotificationCompat.Builder(getApplicationContext(), channel2ID)
                .setContentTitle("Aprieta")
                .setContentText("Lagun eskaera berria")
                .setSmallIcon(R.drawable.logo1);
    }
}
