package com.example.kurama.aprieta;

import android.content.Intent;
import android.graphics.Color;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.squareup.picasso.Picasso;

import de.hdodenhof.circleimageview.CircleImageView;
import io.netopen.hotbitmapgg.library.view.RingProgressBar;

public class PersonProfileActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private SwipeRefreshLayout sw;

    private TextView profileStatus, followerCop, followerCop1, boulderCop, boulderCop1, leveltext;
    private CircleImageView profileImage;
    private Button settingButton;
    private RingProgressBar userlevel;

    private RecyclerView postList;

    private StorageReference postImageReference;
    private DatabaseReference UserRef, PostRef, LikesRef, FriendRequestReference, FriendsRef;
    private FirebaseAuth mAuth;
    private String currentUserID, receiverUserID, username, CURRENT_STATE, EXP, actualEXP, actualLevel;
    private Boolean likeChecker=false;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_person_profile);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        receiverUserID = getIntent().getExtras().get("ProfileKey").toString();
        FriendRequestReference = FirebaseDatabase.getInstance().getReference().child("FriendRequest");
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");
        postImageReference = FirebaseStorage.getInstance().getReference();
        FriendsRef = FirebaseDatabase.getInstance().getReference().child("Users");
        PostRef = FirebaseDatabase.getInstance().getReference().child("Post");
        LikesRef = FirebaseDatabase.getInstance().getReference().child("Likes");

        profileStatus = (TextView) findViewById(R.id.person_status_profile);
        profileImage = (CircleImageView)findViewById(R.id.person_profile_image);
        settingButton = (Button) findViewById(R.id.person_follounfollow_profile_button);
        followerCop = (TextView) findViewById(R.id.person_follower);
        followerCop1 = (TextView) findViewById(R.id.person_follower1);
        boulderCop = (TextView) findViewById(R.id.boulderPerson_cop);
        boulderCop1 = (TextView) findViewById(R.id.boulderPerson_cop1);
        userlevel = findViewById(R.id.userlevel_load2);
        leveltext = findViewById(R.id.leveltext2);

        postList = (RecyclerView) findViewById(R.id.person_user_posts);
        postList.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        postList.setLayoutManager(linearLayoutManager);
        CURRENT_STATE = "not_friends";
        sw = findViewById(R.id.swipePersonProfile);


        UserRef.child(receiverUserID).addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot)
            {
                if(dataSnapshot.exists())
                {
                    if(dataSnapshot.hasChild("username")) {
                        username = dataSnapshot.child("username").getValue().toString();
                        mToolbar = (Toolbar) findViewById(R.id.person_profile_toolbar);
                        setSupportActionBar(mToolbar);
                        getSupportActionBar().setTitle(username);
                        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
                    }

                    if(dataSnapshot.hasChild("profileimage")) {
                        String image = dataSnapshot.child("profileimage").getValue().toString();
                        Picasso.get().load(image).placeholder(R.drawable.profile).into(profileImage);
                    }else {
                        Toast.makeText(PersonProfileActivity.this, "Profile name do not exists...", Toast.LENGTH_SHORT).show();
                    }

                    if(dataSnapshot.hasChild("status")){
                        String status = dataSnapshot.child("status").getValue().toString();
                        profileStatus.setText(status);
                    }

                    if(dataSnapshot.hasChild("Friends")){
                        if(dataSnapshot.child("Friends").hasChild(currentUserID)){
                            settingButton.setText(R.string.profile_unfollow);
                            CURRENT_STATE="friends";
                        }
                        long followers = dataSnapshot.child("Friends").getChildrenCount();
                        followerCop.setText(Long.toString(followers));
                    }
                    if(dataSnapshot.hasChild("doneBoulders")){
                        long boulders = dataSnapshot.child("doneBoulders").getChildrenCount();
                        boulderCop.setText(Long.toString(boulders));
                    }
                    if(dataSnapshot.hasChild("Level")) {
                        EXP = dataSnapshot.child("Level").child("EXP").getValue().toString();
                        actualEXP = dataSnapshot.child("Level").child("actualEXP").getValue().toString();
                        actualLevel = dataSnapshot.child("Level").child("actualLevel").getValue().toString();

                        userlevel.setMax(Integer.parseInt(EXP));
                        userlevel.setProgress(Integer.parseInt(actualEXP));
                        leveltext.setText("Nivel: " + actualLevel);

                        if (actualLevel.equals("1")) {
                            userlevel.setRingProgressColor(Color.WHITE);
                        } else if (actualLevel.equals("2")) {
                            userlevel.setRingProgressColor(Color.GRAY);
                        } else if (actualLevel.equals("3")) {
                            userlevel.setRingProgressColor(Color.rgb(192, 216, 144));
                        } else if (actualLevel.equals("4")) {
                            userlevel.setRingProgressColor(Color.GREEN);
                        } else if (actualLevel.equals("5")) {
                            userlevel.setRingProgressColor(Color.rgb(60, 73, 87));
                        } else if (actualLevel.equals("6")) {
                            userlevel.setRingProgressColor(Color.BLUE);
                        } else if (actualLevel.equals("7")) {
                            userlevel.setRingProgressColor(Color.YELLOW);
                        } else if (actualLevel.equals("8")) {
                            userlevel.setRingProgressColor(Color.rgb(168, 84, 0));
                        } else if (actualLevel.equals("9")) {
                            userlevel.setRingProgressColor(Color.RED);
                        } else if (actualLevel.equals("10")) {
                            userlevel.setRingProgressColor(Color.BLACK);
                        }
                    }

                    ButtonMaintenance();



                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        userlevel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(PersonProfileActivity.this, "EXP:"+EXP+"/"+actualEXP,Toast.LENGTH_LONG ).show();
            }
        });

        followerCop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFriendListActivity();
            }
        });

        followerCop1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFriendListActivity();
            }
        });

        boulderCop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToBoulderList();
            }
        });

        boulderCop1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToBoulderList();
            }
        });

        settingButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(CURRENT_STATE.equals("not_friends")){
                    settingButton.setText(R.string.profile_follow);
                    SendUserFriendRequest();
                }
                if(CURRENT_STATE.equals("request_sent")){
                    settingButton.setText(R.string.profile_cancel);
                    cancelRequest();
                }
                if(CURRENT_STATE.equals("friends")){
                    settingButton.setText(R.string.profile_unfollow);
                    removeUserForFriends();
                }
            }
        });

        sw.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                DisplayUserPosts();
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        sw.setRefreshing(false);
                    }
                },1000);
            }
        });

        DisplayUserPosts();
    }

    private void SendUserToBoulderList() {
        Intent selfIntent = new Intent(PersonProfileActivity.this, PersonDoneBoulderListActivity.class);
        selfIntent.putExtra("ProfileKey", receiverUserID);
        startActivity(selfIntent);
        finish();
    }


    private void SendUserToSelfActivity() {
        Intent clickProfileIntent = new Intent(PersonProfileActivity.this, PersonProfileActivity.class);
        clickProfileIntent.putExtra("ProfileKey", receiverUserID);
        startActivity(clickProfileIntent);
        finish();
    }


    private void SendUserToFriendListActivity() {
        Intent clickProfileIntent = new Intent(PersonProfileActivity.this, PersonFriendListActivity.class);
        clickProfileIntent.putExtra("PersonKey", receiverUserID);
        startActivity(clickProfileIntent);
    }

    private void ButtonMaintenance() {
        FriendRequestReference.child(currentUserID).addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.hasChild(receiverUserID)){
                    String request_type = dataSnapshot.child(receiverUserID).child("request_type").getValue().toString();

                    if(request_type.equals("sent")){
                        CURRENT_STATE = "request_sent";
                        settingButton.setText(R.string.profile_cancel);
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });
    }

    private void removeUserForFriends() {
        FriendsRef.child(currentUserID).child("Friends").child(receiverUserID).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
            @Override
            public void onComplete(@NonNull Task<Void> task) {
                if(task.isSuccessful()){
                    FriendsRef.child(receiverUserID).child("Friends").child(currentUserID).removeValue();
                   /* PostRef.child(currentUserID).child("MyFriendsPosts").removeValue();

                    PostRef.child(receiverUserID).child("MyFriendsPosts").removeValue();*/

                }
            }
        });

        settingButton.setText(R.string.profile_follow);
    }

    private void cancelRequest(){
        FriendRequestReference.child(currentUserID).child(receiverUserID).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
            @Override
            public void onComplete(@NonNull Task<Void> task) {
                if(task.isSuccessful()){
                    FriendRequestReference.child(receiverUserID).child(currentUserID).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                        @Override
                        public void onComplete(@NonNull Task<Void> task) {
                            if(task.isSuccessful()){
                                CURRENT_STATE = "not_friends";
                                settingButton.setText(R.string.profile_follow);
                            }

                        }
                    });

                }
            }
        });
    }

    private void SendUserFriendRequest() {

        FriendRequestReference.child(currentUserID).child(receiverUserID).child("request_type").setValue("sent").addOnCompleteListener(new OnCompleteListener<Void>() {
            @Override
            public void onComplete(@NonNull Task<Void> task) {
                if(task.isSuccessful()){
                    FriendRequestReference.child(receiverUserID).child(currentUserID).child("request_type").setValue("received").addOnCompleteListener(new OnCompleteListener<Void>() {
                        @Override
                        public void onComplete(@NonNull Task<Void> task) {
                            if(task.isSuccessful()){
                                CURRENT_STATE = "request_sent";
                                settingButton.setText(R.string.profile_cancel);
                            }

                        }
                    });

                }
            }
        });

    }

    private void SendUserToCommentActivity(String postKey) {
        Intent commentIntent = new Intent(PersonProfileActivity.this, CommentsActivity.class);
        commentIntent.putExtra("PostKey", postKey);
        startActivity(commentIntent);
    }



    private void DisplayUserPosts() {
        Query SortPostInDescending = PostRef.orderByChild("uid").startAt(receiverUserID).endAt(receiverUserID+"\uf8ff");

        FirebaseRecyclerOptions<Posts> options=new FirebaseRecyclerOptions.Builder<Posts>().setQuery(SortPostInDescending,Posts.class).build();
        FirebaseRecyclerAdapter<Posts, PersonProfileViewHolder> firebaseRecyclerAdapter=new FirebaseRecyclerAdapter<Posts, PersonProfileViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final PersonProfileViewHolder holder, int position, @NonNull final Posts model) {

                final String PostKey = getRef(position).getKey();
                final String uid = model.getUid();

                    holder.time.setText(" " + model.getTime());
                    holder.date.setText(" " + model.getDate());
                    holder.description.setText(model.getStatus());
                UserRef.child(model.getUid()).addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        holder.username.setText(dataSnapshot.child("fullname").getValue().toString());
                        Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(holder.user_post_image);

                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });
                if(model.getType().equals("video")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.VISIBLE);
                }else if(model.getType().equals("image")) {
                    holder.clickForVideo.setVisibility(View.GONE);
                    Picasso.get().load(model.getPostimage()).into(holder.postImage);
                }else if(model.getType().equals("text")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.GONE);
                    holder.clickForText.setVisibility(View.VISIBLE);
                    holder.description.setVisibility(View.GONE);
                    holder.status.setText(model.getStatus());
                }
                    holder.setLikeButtonStatus(PostKey);

                    holder.user_post_image.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            Intent clickProfileIntent = new Intent(PersonProfileActivity.this, PersonProfileActivity.class);
                            clickProfileIntent.putExtra("ProfileKey", uid);
                            startActivity(clickProfileIntent);
                        }
                    });

                holder.clickForText.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(PersonProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.post_video.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(PersonProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.clickForVideo.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(PersonProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.postImage.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(PersonProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.commentPostButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            SendUserToCommentActivity(PostKey);
                        }
                    });

                    holder.likeButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            likeChecker = true;
                            LikesRef.addValueEventListener(new ValueEventListener() {
                                @Override
                                public void onDataChange(DataSnapshot dataSnapshot) {
                                    if(likeChecker.equals(true)){
                                        if(dataSnapshot.child(PostKey).hasChild(currentUserID)){//Like existitzen bada
                                            LikesRef.child(PostKey).child(currentUserID).removeValue();//Ezabatu like-a
                                            likeChecker = false;

                                        }else{//Ez bada like-a eman
                                            LikesRef.child(PostKey).child(currentUserID).setValue(true);
                                            likeChecker = false;
                                        }
                                    }
                                }

                                @Override
                                public void onCancelled(DatabaseError databaseError) {

                                }
                            });

                        }
                    });

            }

            @NonNull
            @Override
            public PersonProfileViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_person_post_layout,parent,false);
                PersonProfileViewHolder viewHolder=new PersonProfileViewHolder(view);
                return viewHolder;
            }
        };
        postList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();

    }

    public static class PersonProfileViewHolder extends RecyclerView.ViewHolder{
        RelativeLayout.LayoutParams params;
        LinearLayout clickForVideo, clickForText;
        TextView username,date,time,description, other, displayNumberOfLikes, status;
        CircleImageView user_post_image;
        ImageView postImage;
        ImageButton likeButton, commentPostButton, post_video;
        int countLikes;
        String currentUserIds;
        DatabaseReference LikesRef;
        View mView;
        LinearLayout linearLayout;
        public PersonProfileViewHolder(View itemView) {
            super(itemView);
            mView = itemView;
            linearLayout = (LinearLayout) mView.findViewById(R.id.linear_person_layout);
            other = mView.findViewById(R.id.text_person_);
            username=mView.findViewById(R.id.post_person_profile_username);
            date=mView.findViewById(R.id.date_person_);
            time=mView.findViewById(R.id.time_person_);
            description=mView.findViewById(R.id.post_description_person_);
            user_post_image=mView.findViewById(R.id.post_profile_person_image);
            params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            postImage=mView.findViewById(R.id.post_image_person_);
            LikesRef= FirebaseDatabase.getInstance().getReference().child("Likes");
            currentUserIds = FirebaseAuth.getInstance().getCurrentUser().getUid();
            displayNumberOfLikes=mView.findViewById(R.id.number_of_likes_person_);
            likeButton=mView.findViewById(R.id.like_button_person_);
            commentPostButton=mView.findViewById(R.id.post_comments_person_);

            clickForVideo = mView.findViewById(R.id.click_for_video_person);
            clickForText = mView.findViewById(R.id.click_for_text_person);
            status = mView.findViewById(R.id.postText_status_person);
            post_video = mView.findViewById(R.id.post_video_person);

        }

        public void setLikeButtonStatus(final String postKey){
            LikesRef.addValueEventListener(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if(dataSnapshot.child(postKey).hasChild(currentUserIds)){
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.like);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }else{
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.dislike);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {

                }
            });
        }

        private void Layout_hide() {
            params.height = 0;
            //itemView.setLayoutParams(params);
             linearLayout.setLayoutParams(params);

        }
    }
}
