package com.example.kurama.aprieta;

import android.app.Activity;
import android.app.Instrumentation;
import android.app.ProgressDialog;
import android.content.ContentResolver;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.media.Image;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.provider.ContactsContract;
import android.provider.MediaStore;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.FileProvider;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.MediaController;
import android.widget.Toast;
import android.widget.VideoView;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.ChildEventListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.theartofdev.edmodo.cropper.CropImage;
import com.theartofdev.edmodo.cropper.CropImageView;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

public class PostActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private ProgressDialog loadingBar;
    private ImageButton imageView;
    private EditText postStatus;

    private final static int Gallery_Pick = 0, Gallery_Video_Pick = 1;

    private Uri ImageUri, VideoUri;

    private MediaController mc;
    private VideoView video;

    private Button post;
    private String Description;
    private StorageReference postImageReference;
    private String saveCurrentDate, saveCurrentTime, postRandomName;
    private String downloadURL1, downloadURL2;

    private DatabaseReference UserRef, PostRef, PostsRef;
    private FirebaseAuth mAuth;
    private FirebaseStorage storage;
    private String currentUserID, type, fullname, profileimage, postRef;
    private long counter = 0, count=0;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_post);

        validate();
        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");
        postImageReference = FirebaseStorage.getInstance().getReference();
        PostRef = FirebaseDatabase.getInstance().getReference().child("Post");
        PostsRef = FirebaseDatabase.getInstance().getReference().child("Post").child(currentUserID);
        storage = FirebaseStorage.getInstance();

        loadingBar = new ProgressDialog(this);
        imageView = (ImageButton) this.findViewById(R.id.postImage);
        post = (Button)findViewById(R.id.updatepost);
        postStatus = (EditText) findViewById(R.id.poststatus);
        video = findViewById(R.id.postVideo);
        video.setVisibility(View.GONE);

        mToolbar = (Toolbar) findViewById(R.id.update_post_page_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setTitle(R.string.add_post_title);



            imageView.setOnClickListener(new View.OnClickListener() {

                 @Override
                 public void onClick(View v) {
                     SelectImage();
                 }

            });

            post.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                    ValidatePostInfo();

                }
            });


    }
    private void requestPermission(){
        ActivityCompat.requestPermissions(this, new String[]{WRITE_EXTERNAL_STORAGE},1);
    }
    private void validate(){
        if (ActivityCompat.checkSelfPermission(this, WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ) {
            requestPermission();
        }
    }

    private void ValidatePostInfo() {
        Description = postStatus.getText().toString();
        if(ImageUri == null && VideoUri == null && (Description == null || Description.equals(""))){
         Toast.makeText(this, R.string.add_post_choose, Toast.LENGTH_LONG).show();
        }
        else if(ImageUri == null && VideoUri == null && (Description != null || !Description.equals(""))){
            loadingBar.setTitle(R.string.add_post_loading);
            loadingBar.show();
            loadingBar.setCanceledOnTouchOutside(true);
            StoringText();

        }else if(ImageUri!=null && VideoUri==null){

            loadingBar.setTitle(R.string.add_post_loading);
            loadingBar.show();
            loadingBar.setCanceledOnTouchOutside(true);
            StoringImage();

        }else if(ImageUri==null && VideoUri!=null){
            loadingBar.setTitle(R.string.add_post_loading);
            loadingBar.show();
            loadingBar.setCanceledOnTouchOutside(true);
            storingVideo();
        }
    }

    private void StoringText() {
        Calendar date = Calendar.getInstance();
        SimpleDateFormat currentDate = new SimpleDateFormat("yyyy-MM-dd");
        saveCurrentDate = currentDate.format(date.getTime());

        Calendar time = Calendar.getInstance();
        SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
        saveCurrentTime = currentTime.format(time.getTime());

        postRandomName = saveCurrentDate + saveCurrentTime;

        postRandomName = postRandomName.replaceAll("\\-", "");

        postRandomName = postRandomName.replaceAll("\\:", "");

        Toast.makeText(PostActivity.this, R.string.add_post_added, Toast.LENGTH_SHORT).show();
        type = "text";
        StoringStatus();

    }

    private void StoringImage() {
        Calendar date = Calendar.getInstance();
        SimpleDateFormat currentDate = new SimpleDateFormat("yyyy-MM-dd");
        saveCurrentDate = currentDate.format(date.getTime());

        Calendar time = Calendar.getInstance();
        SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
        saveCurrentTime = currentTime.format(time.getTime());

        postRandomName = saveCurrentDate + saveCurrentTime;

        postRandomName = postRandomName.replaceAll("\\-", "");

        postRandomName = postRandomName.replaceAll("\\:", "");

        StorageReference filePath1 = postImageReference.child("PostImages").child(ImageUri.getLastPathSegment()+postRandomName+".jpg");

        filePath1.putFile(ImageUri).addOnCompleteListener(new OnCompleteListener<UploadTask.TaskSnapshot>() {
            @Override
            public void onComplete(@NonNull Task<UploadTask.TaskSnapshot> task) {
                if(task.isSuccessful()){
                    postRef = storage.getReferenceFromUrl(task.getResult().getStorage().toString()).toString();
                    downloadURL1 = task.getResult().getDownloadUrl().toString();
                    Toast.makeText(PostActivity.this, R.string.add_post_added, Toast.LENGTH_SHORT).show();
                    type = "image";
                    StoringStatus();

                }else{
                    String message = task.getException().getMessage();
                    Toast.makeText(PostActivity.this, "Error:" + message, Toast.LENGTH_SHORT).show();
                }
            }
        });

        UserRef.child(currentUserID).addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                fullname = dataSnapshot.child("fullname").getValue().toString();
                profileimage = dataSnapshot.child("profileimage").getValue().toString();
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });


    }

    private void storingVideo() {
        Calendar date = Calendar.getInstance();
        SimpleDateFormat currentDate = new SimpleDateFormat("yyyy-MM-dd");
        saveCurrentDate = currentDate.format(date.getTime());

        Calendar time = Calendar.getInstance();
        SimpleDateFormat currentTime = new SimpleDateFormat("HH:mm:ss");
        saveCurrentTime = currentTime.format(time.getTime());

        postRandomName = saveCurrentDate + saveCurrentTime;

        postRandomName = postRandomName.replaceAll("\\-", "");

        postRandomName = postRandomName.replaceAll("\\:", "");

        if (VideoUri == null) {

        } else {

            StorageReference filePath1 = postImageReference.child("PostVideos").child( postRandomName + ".mp4");
            filePath1.putFile(VideoUri).addOnCompleteListener(new OnCompleteListener<UploadTask.TaskSnapshot>() {
                @Override
                public void onComplete(@NonNull Task<UploadTask.TaskSnapshot> task) {
                    if (task.isSuccessful()) {
                        postRef = storage.getReferenceFromUrl(task.getResult().getStorage().toString()).toString();
                        downloadURL1 = task.getResult().getDownloadUrl().toString();
                        Toast.makeText(PostActivity.this, R.string.add_post_added, Toast.LENGTH_SHORT).show();
                        type = "video";
                        StoringStatus();
                    } else {
                        String message = task.getException().getMessage();
                        Toast.makeText(PostActivity.this, "Error:" + message, Toast.LENGTH_SHORT).show();
                    }
                }
            });
        }
    }

    private void StoringStatus() {
        UserRef.child(currentUserID).addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(final DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){

                    String userFullName = dataSnapshot.child("fullname").getValue().toString();
                    String userProfileImage = dataSnapshot.child("profileimage").getValue().toString();

                    if(downloadURL1 == null){
                        downloadURL1="";
                    }
                    if(Description == null){
                        Description="";
                    }
                    if(postRef == null){
                        postRef="";
                    }

                    final HashMap postMap = new HashMap();
                    postMap.put("postID", postRandomName);
                    postMap.put("type", type);
                    postMap.put("uid", currentUserID);
                    postMap.put("date", saveCurrentDate);
                    postMap.put("time", saveCurrentTime);
                    postMap.put("status", Description);
                    postMap.put("storedpath", postRef);
                    postMap.put("postimage", downloadURL1);
                    postMap.put("profileimage", userProfileImage);
                    postMap.put("fullname", userFullName);


                    PostRef.child(postRandomName).updateChildren(postMap).addOnCompleteListener(new OnCompleteListener() {
                        @Override
                        public void onComplete(@NonNull Task task) {
                            if (task.isSuccessful()) {
                                SendUserToMainActivity();
                                loadingBar.dismiss();
                            }else{
                                Toast.makeText(PostActivity.this, "Error:", Toast.LENGTH_SHORT).show();
                                loadingBar.dismiss();
                            }
                        }
                    });

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });


    }


    private void openGallery() {

        if (ActivityCompat.checkSelfPermission(this, WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ) {
            Toast.makeText(this, "Para subir una publicación con multimedia debes aceptar los permisos!", Toast.LENGTH_SHORT).show();
            SendUserToMainActivity();
        }else {
            Intent galleryIntent = new Intent();
            galleryIntent.setAction(Intent.ACTION_GET_CONTENT);
            galleryIntent.setType("image/*");
            startActivityForResult(galleryIntent, Gallery_Pick);
        }
    }

    private void openGalleryVideo() {
        if (ActivityCompat.checkSelfPermission(this, WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ) {
            Toast.makeText(this, "Para subir una publicación con multimedia debes aceptar los permisos!", Toast.LENGTH_SHORT).show();
            SendUserToMainActivity();
        }else {
            Intent galleryIntent = new Intent();
            galleryIntent.setAction(Intent.ACTION_GET_CONTENT);
            galleryIntent.setType("video/*");
            startActivityForResult(galleryIntent, Gallery_Video_Pick);
        }
    }


        private void SelectImage(){
            final CharSequence[] item ={"Imagen","Vídeo"};

            AlertDialog.Builder builder = new AlertDialog.Builder(PostActivity.this);
            builder.setTitle("Elige un tipo de archivo");
            builder.setItems(item, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int i) {
                    if(item[i].equals("Vídeo")){
                        openGalleryVideo();


                    }else if(item[i].equals("Imagen")){
                        openGallery();
                    }
                }
            });
            builder.show();
        }


        @Override
        public void onActivityResult(int requestCode, int resultCode, Intent data){
            super.onActivityResult(resultCode,resultCode,data);
            int dataSize=0;
            if (requestCode == Gallery_Video_Pick && resultCode == RESULT_OK && data != null) {
                video.setVisibility(View.VISIBLE);
                imageView.setVisibility(View.GONE);
                VideoUri = data.getData();
                String scheme = VideoUri.getScheme();

                if(scheme.equals(ContentResolver.SCHEME_CONTENT))
                {
                    try {
                        InputStream fileInputStream=getApplicationContext().getContentResolver().openInputStream(VideoUri);
                        dataSize = fileInputStream.available();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    System.out.println("File size in bytes"+dataSize);

                }
                else if(scheme.equals(ContentResolver.SCHEME_FILE))
                {
                    String path = VideoUri.getPath();
                    try {
                        File f = new File(path);
                        dataSize = (int)f.length();
                        System.out.println("File size in bytes"+f.length());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }

                if(dataSize<=8406364) {
                    MediaController mediaController = new MediaController(this);
                    mediaController.setAnchorView(video);

                    video.setMediaController(mediaController);
                    video.setVideoURI(VideoUri);
                    video.start();
                }else{
                    Toast.makeText(this, "El video que quieres subir es demasiado grande\nPor favor, eliga uno de menor tamaño o baje la resolución al grabar", Toast.LENGTH_LONG).show();
                }

            }

           if(requestCode==Gallery_Pick && resultCode==RESULT_OK && data!=null){
                video.setVisibility(View.GONE);
                imageView.setVisibility(View.VISIBLE);
                ImageUri = data.getData();
                CropImage.activity(ImageUri)
                        .setGuidelines(CropImageView.Guidelines.ON)
                        .setAspectRatio(1, 1)
                        .start(this);
                //imageView.setImageURI(selectedImageUri);
            }

            if(requestCode==CropImage.CROP_IMAGE_ACTIVITY_REQUEST_CODE)
            {
                CropImage.ActivityResult result = CropImage.getActivityResult(data);

                if(resultCode == RESULT_OK)
                {
                    ImageUri = result.getUri();

                    try {

                        Bitmap bitmap = MediaStore.Images.Media.getBitmap(this.getContentResolver(), ImageUri);
                        int nh = (int) ( bitmap.getHeight() * (512.0 / bitmap.getWidth()) );
                        Bitmap scaled = Bitmap.createScaledBitmap(bitmap, 512, nh, true);
                        String path = MediaStore.Images.Media.insertImage(this.getContentResolver(), scaled, "Title", null);
                        ImageUri = Uri.parse(path);
                        imageView.setImageBitmap(bitmap);

                    } catch (IOException e) {
                        e.printStackTrace();
                    }


                }
            }

        }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if(id == android.R.id.home){
            SendUserToMainActivity();
        }

        return super.onOptionsItemSelected(item);
    }

    private void SendUserToMainActivity() {
        Intent mainIntent = new Intent(PostActivity.this, MainActivity.class);
        startActivity(mainIntent);
        finish();
    }
}
