package com.example.kurama.aprieta;

import android.content.Intent;
import android.graphics.Color;
import android.net.Uri;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.squareup.picasso.Picasso;

import org.w3c.dom.Text;

import de.hdodenhof.circleimageview.CircleImageView;
import io.netopen.hotbitmapgg.library.view.RingProgressBar;

public class ProfileActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private SwipeRefreshLayout sw;

    private TextView profileStatus, followerCop, followerCop1, boulderCop, boulderCop1, leveltext;
    private CircleImageView profileImage;
    private Button settingButton;
    private RingProgressBar userlevel;
    private FloatingActionButton statsButton;

    private RecyclerView postList;

    private StorageReference postImageReference;
    private DatabaseReference UserRef, PostRef, LikesRef;
    private FirebaseAuth mAuth;
    private String currentUserID, username, EXP, actualEXP, actualLevel;
    private Boolean likeChecker=false;
    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_profile);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");
        postImageReference = FirebaseStorage.getInstance().getReference();
        PostRef = FirebaseDatabase.getInstance().getReference().child("Post");
        LikesRef = FirebaseDatabase.getInstance().getReference().child("Likes");
        sw = findViewById(R.id.swipeProfile);

        profileStatus = (TextView) findViewById(R.id.status_profile);
        profileImage = (CircleImageView)findViewById(R.id.profile_image);
        settingButton = (Button) findViewById(R.id.edit_profile_button);
        followerCop = (TextView) findViewById(R.id.follower_cop);
        followerCop1 = (TextView) findViewById(R.id.follower_cop1);
        boulderCop = (TextView) findViewById(R.id.boulder_cop);
        boulderCop1 = (TextView) findViewById(R.id.boulder_cop1);
        userlevel = findViewById(R.id.userlevel_load);
        leveltext = findViewById(R.id.leveltext);
        statsButton = findViewById(R.id.floatingActionButton);

        postList = (RecyclerView) findViewById(R.id.user_posts);
        postList.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        postList.setLayoutManager(linearLayoutManager);

        settingButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToSettingsActivity();
            }
        });

        statsButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToStatsActivity();
            }
        });


        UserRef.child(currentUserID).addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot)
            {
                if(dataSnapshot.exists())
                {
                    if(dataSnapshot.hasChild("username")) {
                        username = dataSnapshot.child("username").getValue().toString();
                        mToolbar = (Toolbar) findViewById(R.id.profile_toolbar);
                        setSupportActionBar(mToolbar);
                        getSupportActionBar().setTitle(username);
                        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
                    }

                    if(dataSnapshot.hasChild("profileimage")) {
                        String image = dataSnapshot.child("profileimage").getValue().toString();
                        Picasso.get().load(image).placeholder(R.drawable.profile).into(profileImage);
                    }else {
                        Toast.makeText(ProfileActivity.this, "Profile name do not exists...", Toast.LENGTH_SHORT).show();
                    }

                    if(dataSnapshot.hasChild("status")){
                        String status = dataSnapshot.child("status").getValue().toString();
                        profileStatus.setText(status);
                    }
                    if(dataSnapshot.hasChild("Friends")){
                        long followers = dataSnapshot.child("Friends").getChildrenCount();
                        followerCop.setText(Long.toString(followers));
                    }
                    if(dataSnapshot.hasChild("doneBoulders")){
                        long boulders = dataSnapshot.child("doneBoulders").getChildrenCount();
                        boulderCop.setText(Long.toString(boulders));

                    }
                    if(dataSnapshot.hasChild("Level")){
                        EXP = dataSnapshot.child("Level").child("EXP").getValue().toString();
                        actualEXP = dataSnapshot.child("Level").child("actualEXP").getValue().toString();
                        actualLevel = dataSnapshot.child("Level").child("actualLevel").getValue().toString();

                        userlevel.setMax(Integer.parseInt(EXP));
                        userlevel.setProgress(Integer.parseInt(actualEXP));
                        leveltext.setText("Nivel: "+actualLevel);

                        if(actualLevel.equals("1")){
                            userlevel.setRingProgressColor(Color.WHITE);
                        }else if(actualLevel.equals("2")){
                            userlevel.setRingProgressColor(Color.GRAY);
                        }else if(actualLevel.equals("3")){
                            userlevel.setRingProgressColor(Color.rgb(192,216,144));
                        }else if(actualLevel.equals("4")){
                            userlevel.setRingProgressColor(Color.GREEN);
                        }else if(actualLevel.equals("5")){
                            userlevel.setRingProgressColor(Color.rgb(60,73,87));
                        }else if(actualLevel.equals("6")){
                            userlevel.setRingProgressColor(Color.BLUE);
                        }else if(actualLevel.equals("7")){
                            userlevel.setRingProgressColor(Color.YELLOW);
                        }else if(actualLevel.equals("8")){
                            userlevel.setRingProgressColor(Color.rgb(168, 84, 0));
                        }else if(actualLevel.equals("9")){
                            userlevel.setRingProgressColor(Color.RED);
                        }else if(actualLevel.equals("10")){
                            userlevel.setRingProgressColor(Color.BLACK);
                        }
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });
        userlevel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(ProfileActivity.this, "EXP:"+EXP+"/"+actualEXP,Toast.LENGTH_LONG ).show();
            }
        });
        followerCop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFriendListActivity();
            }
        });

        followerCop1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToFriendListActivity();
            }
        });

        boulderCop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToBoulderList();
            }
        });

        boulderCop1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SendUserToBoulderList();
            }
        });

        sw.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                DisplayUserPosts();
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        sw.setRefreshing(false);
                    }
                },1000);
            }
        });

        DisplayUserPosts();
    }

    private void SendUserToBoulderList() {
        Intent selfIntent = new Intent(ProfileActivity.this, DoneBoulderListAcitivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserToSelfActivity() {
        Intent selfIntent = new Intent(ProfileActivity.this, ProfileActivity.class);
        startActivity(selfIntent);
        finish();
    }

    private void SendUserToFriendListActivity() {
        Intent friendListIntent = new Intent(ProfileActivity.this, FriendListActivity.class);
        startActivity(friendListIntent);
    }

    private void SendUserToSettingsActivity() {
        Intent settingIntent = new Intent(ProfileActivity.this, SettingsActivity.class);
        startActivity(settingIntent);
        finish();
    }

    private void SendUserToStatsActivity() {
        Intent statsIntent = new Intent(ProfileActivity.this, StatsActivity.class);
        startActivity(statsIntent);
        finish();
    }

    private void SendUserToCommentActivity(String postKey) {
        Intent commentIntent = new Intent(ProfileActivity.this, CommentsActivity.class);
        commentIntent.putExtra("PostKey", postKey);
        startActivity(commentIntent);
    }

    private void DisplayUserPosts() {
        Query SortPostInDescending = PostRef.orderByChild("uid").startAt(currentUserID).endAt(currentUserID+"\uf8ff");
        FirebaseRecyclerOptions<Posts> options=new FirebaseRecyclerOptions.Builder<Posts>().setQuery(SortPostInDescending,Posts.class).build();
        FirebaseRecyclerAdapter<Posts, ProfileActivity.PostsViewHolder> firebaseRecyclerAdapter=new FirebaseRecyclerAdapter<Posts, ProfileActivity.PostsViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final ProfileActivity.PostsViewHolder holder, int position, @NonNull final Posts model) {
                final String PostKey = getRef(position).getKey();
                final String uid = model.getUid();

                    holder.time.setText(" " + model.getTime());
                    holder.date.setText(" " + model.getDate());
                    holder.description.setText(model.getStatus());
                    //holder.user_post_image.setImageURI(Uri.parse(model.getProfileimage()));
                    //holder.postImage.setImageURI(Uri.parse(model.getPostimage()));
                UserRef.child(model.getUid()).addValueEventListener(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        holder.username.setText(dataSnapshot.child("fullname").getValue().toString());
                        Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(holder.user_post_image);

                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });
                if(model.getType().equals("video")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.VISIBLE);
                }else if(model.getType().equals("image")) {
                    holder.clickForVideo.setVisibility(View.GONE);
                    Picasso.get().load(model.getPostimage()).into(holder.postImage);
                }else if(model.getType().equals("text")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.GONE);
                    holder.clickForText.setVisibility(View.VISIBLE);
                    holder.description.setVisibility(View.GONE);
                    holder.status.setText(model.getStatus());
                }
                    holder.setLikeButtonStatus(PostKey);

                    holder.user_post_image.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            Intent clickProfileIntent = new Intent(ProfileActivity.this, PersonProfileActivity.class);
                            clickProfileIntent.putExtra("ProfileKey", uid);
                            startActivity(clickProfileIntent);
                        }
                    });

                holder.clickForText.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.post_video.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.clickForVideo.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.postImage.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });



                    holder.commentPostButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            SendUserToCommentActivity(PostKey);
                        }
                    });

                    holder.likeButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            likeChecker = true;
                            LikesRef.addValueEventListener(new ValueEventListener() {
                                @Override
                                public void onDataChange(DataSnapshot dataSnapshot) {
                                    if(likeChecker.equals(true)){
                                        if(dataSnapshot.child(PostKey).hasChild(currentUserID)){//Like existitzen bada
                                            LikesRef.child(PostKey).child(currentUserID).removeValue();//Ezabatu like-a
                                            likeChecker = false;

                                        }else{//Ez bada like-a eman
                                            LikesRef.child(PostKey).child(currentUserID).setValue(true);
                                            likeChecker = false;
                                        }
                                    }
                                }

                                @Override
                                public void onCancelled(DatabaseError databaseError) {

                                }
                            });

                        }
                    });


            }

            @NonNull
            @Override
            public ProfileActivity.PostsViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_post_layout,parent,false);
                ProfileActivity.PostsViewHolder viewHolder=new ProfileActivity.PostsViewHolder(view);
                return viewHolder;
            }
        };
        postList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();

    }

    public static class PostsViewHolder extends RecyclerView.ViewHolder{
        LinearLayout.LayoutParams params;
        LinearLayout clickForVideo, clickForText;
        TextView username,date,time,description, other, displayNumberOfLikes, status;
        CircleImageView user_post_image;
        ImageView postImage;
        ImageButton likeButton, commentPostButton, post_video;
        int countLikes;
        String currentUserIds;
        DatabaseReference LikesRef;
        View mView;
        LinearLayout linearLayout;
        public PostsViewHolder(View itemView) {
            super(itemView);
            mView = itemView;
            linearLayout = (LinearLayout) mView.findViewById(R.id.linear_layout);
            other = mView.findViewById(R.id.text);
            username=mView.findViewById(R.id.post_profile_username);
            date=mView.findViewById(R.id.date);
            time=mView.findViewById(R.id.time);
            description=mView.findViewById(R.id.post_description);
            postImage=mView.findViewById(R.id.post_image);
            user_post_image=mView.findViewById(R.id.post_profile_image);
            params = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            description=mView.findViewById(R.id.post_description);
            postImage=mView.findViewById(R.id.post_image);
            user_post_image=mView.findViewById(R.id.post_profile_image);
            LikesRef= FirebaseDatabase.getInstance().getReference().child("Likes");
            currentUserIds = FirebaseAuth.getInstance().getCurrentUser().getUid();
            displayNumberOfLikes=mView.findViewById(R.id.number_of_likes);
            likeButton=mView.findViewById(R.id.like_button);
            commentPostButton=mView.findViewById(R.id.post_comments);

            clickForVideo = mView.findViewById(R.id.click_for_video);
            clickForText = mView.findViewById(R.id.click_for_text);
            status = mView.findViewById(R.id.postText_status);
            post_video = mView.findViewById(R.id.post_video);

        }

        public void setLikeButtonStatus(final String postKey){
            LikesRef.addValueEventListener(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if(dataSnapshot.child(postKey).hasChild(currentUserIds)){
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.like);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }else{
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.dislike);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {

                }
            });
        }

        void Layout_hide() {
            params.height = 0;
            itemView.setLayoutParams(params);
           // linearLayout.setLayoutParams(params);

        }
    }

}
