package com.example.kurama.aprieta;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.widget.SwipeRefreshLayout;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.firebase.ui.database.FirebaseRecyclerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.squareup.picasso.Picasso;

import de.hdodenhof.circleimageview.CircleImageView;
import io.netopen.hotbitmapgg.library.view.RingProgressBar;

public class ProfileForAdminActivity extends AppCompatActivity {
    private Toolbar mToolbar;
    private SwipeRefreshLayout sw;

    private TextView profileStatus, followerCop, followerCop1, boulderCop, boulderCop1, leveltext;
    private CircleImageView profileImage;
    private ImageButton removeUser;
    private Button settingButton;
    private RingProgressBar userlevel;

    private RecyclerView postList;

    private StorageReference postImageReference;
    private DatabaseReference UserRef, PostRef, LikesRef, AdminRef, BoulderRef, ChallengeRef;
    private FirebaseAuth mAuth;
    private FirebaseStorage storage;
    private String currentUserID, receiverUserID, username, CURRENT_STATE, EXP, actualEXP, actualLevel;
    private Boolean likeChecker=false;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        SendUserToMainActivity();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_profile_for_admin);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        receiverUserID = getIntent().getExtras().get("ProfileKey").toString();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users");
        storage = FirebaseStorage.getInstance();
        postImageReference = FirebaseStorage.getInstance().getReference();
        PostRef = FirebaseDatabase.getInstance().getReference().child("Post");
        AdminRef = FirebaseDatabase.getInstance().getReference().child("Admin");
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        ChallengeRef = FirebaseDatabase.getInstance().getReference().child("Challenges");
        LikesRef = FirebaseDatabase.getInstance().getReference().child("Likes");
        sw = findViewById(R.id.admin_swipePersonProfile);

        profileStatus = (TextView) findViewById(R.id.admin_person_status_profile);
        profileImage = (CircleImageView)findViewById(R.id.admin_person_profile_image);
        followerCop = (TextView) findViewById(R.id.admin_person_follower);
        followerCop1 = (TextView) findViewById(R.id.admin_person_follower1);
        boulderCop = (TextView) findViewById(R.id.admin_boulderPerson_cop);
        boulderCop1 = (TextView) findViewById(R.id.admin_boulderPerson_cop1);
        removeUser = findViewById(R.id.removeUser);

        postList = (RecyclerView) findViewById(R.id.admin_person_user_posts);
        postList.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
        linearLayoutManager.setReverseLayout(true);
        linearLayoutManager.setStackFromEnd(true);
        postList.setLayoutManager(linearLayoutManager);

        removeUser.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AlertDialog.Builder builder = new AlertDialog.Builder(ProfileForAdminActivity.this);
                builder.setTitle(R.string.admin_deleteUser);
                builder.setPositiveButton(R.string.boulder_profile_removeAlert, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        AdminRef.child("MessagesWith").addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()){
                                    if(dataSnapshot.hasChild(receiverUserID)){
                                        AdminRef.child("MessagesWith").child(receiverUserID).removeValue();
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        PostRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()){
                                    for(DataSnapshot ds : dataSnapshot.getChildren()){
                                        if(ds.child("uid").getValue().toString().equals(receiverUserID)) {
                                            postImageReference = storage.getReferenceFromUrl(ds.child("storedpath").getValue().toString());
                                            postImageReference.delete();
                                            PostRef.child(ds.getKey()).removeValue();
                                        }
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        BoulderRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()){
                                    for(final DataSnapshot ds1 : dataSnapshot.getChildren()){
                                        if(ds1.child("userid").getValue().toString().equals(receiverUserID)) {
                                            for (DataSnapshot ds2 : ds1.child("BoulderImages").getChildren()) {
                                                postImageReference = storage.getReferenceFromUrl(ds2.child("profilestorage").getValue().toString());
                                                postImageReference.delete();
                                            }
                                            for (DataSnapshot ds3 : ds1.child("BoulderVideos").getChildren()) {
                                                postImageReference = storage.getReferenceFromUrl(ds3.child("videostorage").getValue().toString());
                                                postImageReference.delete();
                                            }
                                            UserRef.addListenerForSingleValueEvent(new ValueEventListener() {
                                                @Override
                                                public void onDataChange(DataSnapshot dataSnapshot) {
                                                    if(dataSnapshot.exists()){
                                                        for(DataSnapshot ds : dataSnapshot.getChildren()){
                                                            if(ds.hasChild("doneBoulders")) {
                                                                UserRef.child(ds.getKey()).child("doneBoulders").child(ds1.getKey()).removeValue();
                                                            }
                                                            if(ds.hasChild("toDoBoulders")){
                                                                UserRef.child(ds.getKey()).child("toDoBoulders").child(ds1.getKey()).removeValue();
                                                            }
                                                            if(dataSnapshot.child(ds.getKey()).child("likeBoulder").exists()){
                                                                UserRef.child(ds.getKey()).child("likeBoulder").child(ds1.getKey()).removeValue();
                                                            }
                                                        }
                                                    }
                                                }

                                                @Override
                                                public void onCancelled(DatabaseError databaseError) {

                                                }
                                            });

                                            ChallengeRef.addListenerForSingleValueEvent(new ValueEventListener() {
                                                @Override
                                                public void onDataChange(DataSnapshot dataSnapshot) {
                                                    if(dataSnapshot.exists()){
                                                        for(final DataSnapshot ds : dataSnapshot.getChildren()){
                                                            if(ds.child("Boulders").child(ds1.getKey()).exists()){
                                                                ChallengeRef.child(ds.getKey()).child("Boulders").child(ds1.getKey()).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                                                    @Override
                                                                    public void onComplete(@NonNull Task<Void> task) {
                                                                        if(task.isSuccessful()){
                                                                            BoulderRef.child(ds1.getKey()).removeValue().addOnCompleteListener(new OnCompleteListener<Void>() {
                                                                                @Override
                                                                                public void onComplete(@NonNull Task<Void> task) {
                                                                                    if(task.isSuccessful()) {

                                                                                        if (ds.child("Boulders").getChildrenCount()== 1) {
                                                                                            ChallengeRef.child(ds.getKey()).removeValue();
                                                                                            UserRef.addListenerForSingleValueEvent(new ValueEventListener() {
                                                                                                @Override
                                                                                                public void onDataChange(DataSnapshot dataSnapshot) {
                                                                                                    for(DataSnapshot ds2 : dataSnapshot.getChildren()){
                                                                                                        if(dataSnapshot.child(ds2.getKey()).child("OwnChallenges").hasChild(ds.getKey())){
                                                                                                            UserRef.child(ds2.getKey()).child("OwnChallenges").child(ds.getKey()).removeValue();
                                                                                                        }
                                                                                                    }
                                                                                                }

                                                                                                @Override
                                                                                                public void onCancelled(DatabaseError databaseError) {

                                                                                                }
                                                                                            });
                                                                                        }

                                                                                    }

                                                                                }
                                                                            });

                                                                        }
                                                                    }
                                                                });

                                                            }
                                                        }
                                                    }
                                                }

                                                @Override
                                                public void onCancelled(DatabaseError databaseError) {

                                                }
                                            });

                                        }
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        UserRef.addListenerForSingleValueEvent(new ValueEventListener() {
                            @Override
                            public void onDataChange(DataSnapshot dataSnapshot) {
                                if(dataSnapshot.exists()){
                                    for(DataSnapshot ds : dataSnapshot.getChildren()){

                                        for (DataSnapshot ds2 : ds.child("Friends").getChildren()) {
                                            if(ds2.getKey().equals(receiverUserID)){
                                                UserRef.child(ds.getKey()).child("Friends").child(ds2.getKey()).removeValue();

                                            }
                                        }
                                    }
                                }
                            }

                            @Override
                            public void onCancelled(DatabaseError databaseError) {

                            }
                        });

                        UserRef.child(receiverUserID).removeValue();
                        SendUserToMainActivity();
                    }
                });
                builder.setNegativeButton(R.string.post_edit_cancel, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        dialog.cancel();
                    }
                });
                AlertDialog dialog = builder.create();
                dialog.show();

            }
        });

        UserRef.child(receiverUserID).addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot)
            {
                if(dataSnapshot.exists())
                {
                    if(dataSnapshot.hasChild("username")) {
                        username = dataSnapshot.child("username").getValue().toString();
                        mToolbar = (Toolbar) findViewById(R.id.admin_person_profile_toolbar);
                        setSupportActionBar(mToolbar);
                        getSupportActionBar().setTitle(username);
                        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
                    }

                    if(dataSnapshot.hasChild("profileimage")) {
                        String image = dataSnapshot.child("profileimage").getValue().toString();
                        Picasso.get().load(image).placeholder(R.drawable.profile).into(profileImage);
                    }else {
                        Toast.makeText(ProfileForAdminActivity.this, "Profile name do not exists...", Toast.LENGTH_SHORT).show();
                    }

                    if(dataSnapshot.hasChild("status")){
                        String status = dataSnapshot.child("status").getValue().toString();
                        profileStatus.setText(status);
                    }

                    if(dataSnapshot.hasChild("Friends")){
                        long followers = dataSnapshot.child("Friends").getChildrenCount();
                        followerCop.setText(Long.toString(followers));
                    }
                    if(dataSnapshot.hasChild("doneBoulders")){
                        long boulders = dataSnapshot.child("doneBoulders").getChildrenCount();
                        boulderCop.setText(Long.toString(boulders));
                    }
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        sw.setOnRefreshListener(new SwipeRefreshLayout.OnRefreshListener() {
            @Override
            public void onRefresh() {
                DisplayUserPosts();
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        sw.setRefreshing(false);
                    }
                },1000);
            }
        });

        DisplayUserPosts();
    }

    private void SendUserToMainActivity() {
        Intent mainIntent = new Intent(ProfileForAdminActivity.this, Main2Activity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
    }



    private void DisplayUserPosts() {
        Query SortPostInDescending = PostRef.orderByChild("uid").startAt(receiverUserID).endAt(receiverUserID+"\uf8ff");

        FirebaseRecyclerOptions<Posts> options=new FirebaseRecyclerOptions.Builder<Posts>().setQuery(SortPostInDescending,Posts.class).build();
        FirebaseRecyclerAdapter<Posts, ProfileForAdminActivity.PersonProfileViewHolder> firebaseRecyclerAdapter=new FirebaseRecyclerAdapter<Posts, ProfileForAdminActivity.PersonProfileViewHolder>(options) {
            @Override
            protected void onBindViewHolder(@NonNull final ProfileForAdminActivity.PersonProfileViewHolder holder, int position, @NonNull final Posts model) {

                final String PostKey = getRef(position).getKey();
                final String uid = model.getUid();

                holder.time.setText(" " + model.getTime());
                holder.date.setText(" " + model.getDate());
                holder.description.setText(model.getStatus());
                UserRef.child(model.getUid()).addListenerForSingleValueEvent(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        if(dataSnapshot.exists()) {
                            holder.username.setText(dataSnapshot.child("fullname").getValue().toString());
                            Picasso.get().load(dataSnapshot.child("profileimage").getValue().toString()).into(holder.user_post_image);
                        }
                    }

                    @Override
                    public void onCancelled(DatabaseError databaseError) {

                    }
                });
                if(model.getType().equals("video")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.VISIBLE);
                }else if(model.getType().equals("image")) {
                    holder.clickForVideo.setVisibility(View.GONE);
                    Picasso.get().load(model.getPostimage()).into(holder.postImage);
                }else if(model.getType().equals("text")){
                    holder.postImage.setVisibility(View.GONE);
                    holder.clickForVideo.setVisibility(View.GONE);
                    holder.clickForText.setVisibility(View.VISIBLE);
                    holder.description.setVisibility(View.GONE);
                    holder.status.setText(model.getStatus());
                }
                holder.setLikeButtonStatus(PostKey);

                holder.user_post_image.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickProfileIntent = new Intent(ProfileForAdminActivity.this, ProfileForAdminActivity.class);
                        clickProfileIntent.putExtra("ProfileKey", uid);
                        startActivity(clickProfileIntent);
                    }
                });

                holder.clickForText.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileForAdminActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.post_video.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileForAdminActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.clickForVideo.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileForAdminActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.postImage.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        Intent clickPostIntent = new Intent(ProfileForAdminActivity.this, ClickPostAcitivity.class);
                        clickPostIntent.putExtra("PostKey", PostKey);
                        clickPostIntent.putExtra("type", model.getType());
                        startActivity(clickPostIntent);
                    }
                });

                holder.commentPostButton.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        SendUserToCommentActivity(PostKey);
                    }
                });

            }

            @NonNull
            @Override
            public ProfileForAdminActivity.PersonProfileViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
                View view=LayoutInflater.from(parent.getContext()).inflate(R.layout.all_person_post_layout,parent,false);
                ProfileForAdminActivity.PersonProfileViewHolder viewHolder=new ProfileForAdminActivity.PersonProfileViewHolder(view);
                return viewHolder;
            }
        };
        postList.setAdapter(firebaseRecyclerAdapter);
        firebaseRecyclerAdapter.startListening();

    }

    private void SendUserToCommentActivity(String postKey) {
        Intent commentIntent = new Intent(ProfileForAdminActivity.this, CommentsActivity.class);
        commentIntent.putExtra("PostKey", postKey);
        startActivity(commentIntent);
    }

    public static class PersonProfileViewHolder extends RecyclerView.ViewHolder {
        RelativeLayout.LayoutParams params;
        LinearLayout clickForVideo, clickForText;
        TextView username, date, time, description, other, displayNumberOfLikes, status;
        CircleImageView user_post_image;
        ImageView postImage;
        ImageButton likeButton, commentPostButton, post_video;
        int countLikes;
        String currentUserIds;
        DatabaseReference LikesRef;
        View mView;
        LinearLayout linearLayout;

        public PersonProfileViewHolder(View itemView) {
            super(itemView);
            mView = itemView;
            linearLayout = (LinearLayout) mView.findViewById(R.id.linear_person_layout);
            other = mView.findViewById(R.id.text_person_);
            username = mView.findViewById(R.id.post_person_profile_username);
            date = mView.findViewById(R.id.date_person_);
            time = mView.findViewById(R.id.time_person_);
            description = mView.findViewById(R.id.post_description_person_);
            user_post_image = mView.findViewById(R.id.post_profile_person_image);
            params = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            postImage = mView.findViewById(R.id.post_image_person_);
            LikesRef = FirebaseDatabase.getInstance().getReference().child("Likes");
            currentUserIds = FirebaseAuth.getInstance().getCurrentUser().getUid();
            displayNumberOfLikes = mView.findViewById(R.id.number_of_likes_person_);
            likeButton = mView.findViewById(R.id.like_button_person_);
            commentPostButton = mView.findViewById(R.id.post_comments_person_);

            clickForVideo = mView.findViewById(R.id.click_for_video_person);
            clickForText = mView.findViewById(R.id.click_for_text_person);
            status = mView.findViewById(R.id.postText_status_person);
            post_video = mView.findViewById(R.id.post_video_person);

        }
        public void setLikeButtonStatus(final String postKey){
            LikesRef.addValueEventListener(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if(dataSnapshot.child(postKey).hasChild(currentUserIds)){
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.like);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }else{
                        countLikes = (int) dataSnapshot.child(postKey).getChildrenCount();
                        likeButton.setImageResource(R.drawable.dislike);
                        displayNumberOfLikes.setText(Integer.toString(countLikes));
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {

                }
            });
        }
    }
}
