package com.example.kurama.aprieta;

import android.content.Intent;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;

public class ResetPasswordActivity extends AppCompatActivity {

    private Button ResetPasswordSendEmail;
    private EditText ResetPasswordEmail;

    private FirebaseAuth mAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reset_password);

        mAuth = FirebaseAuth.getInstance();

        ResetPasswordSendEmail = (Button) findViewById(R.id.password_request);
        ResetPasswordEmail = (EditText) findViewById(R.id.emailpassword);

        ResetPasswordSendEmail.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String email = ResetPasswordEmail.getText().toString();

                if(TextUtils.isEmpty(email)) {
                    Toast.makeText(ResetPasswordActivity.this, R.string.forgotpass_email_noty, Toast.LENGTH_SHORT).show();
                }else{
                    mAuth.sendPasswordResetEmail(email).addOnCompleteListener(new OnCompleteListener<Void>() {
                        @Override
                        public void onComplete(@NonNull Task<Void> task) {
                            if(task.isSuccessful()){
                                Toast.makeText(ResetPasswordActivity.this, R.string.forgotpass_result, Toast.LENGTH_LONG).show();
                                SendUserToLoginActivity();
                                finish();
                            }else{
                                String message =  task.getException().getMessage();
                                Toast.makeText(ResetPasswordActivity.this, "Error: "+message, Toast.LENGTH_LONG).show();
                            }
                        }
                    });
                }
            }
        });
    }

    private void SendUserToLoginActivity() {
        Intent loginIntent = new Intent(ResetPasswordActivity.this, LoginActivity.class);
        startActivity(loginIntent);

    }
}
