package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.Intent;
import android.net.Uri;
import android.os.storage.StorageManager;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.transition.CircularPropagation;
import android.view.View;
import android.widget.Button;
import android.widget.CursorAdapter;
import android.widget.EditText;
import android.widget.Toast;

import com.example.kurama.aprieta.MainActivity;
import com.example.kurama.aprieta.R;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;
import com.google.firebase.storage.UploadTask;
import com.squareup.picasso.Picasso;
import com.theartofdev.edmodo.cropper.CropImage;
import com.theartofdev.edmodo.cropper.CropImageView;

import java.util.HashMap;

import de.hdodenhof.circleimageview.CircleImageView;

public class SetUpActivity extends AppCompatActivity
{
    private EditText UserName, FullName, CountryName;
    private Button SaveInformationbuttion;
    private CircleImageView ProfileImage;
    private ProgressDialog loadingBar;

    private FirebaseAuth mAuth;
    private DatabaseReference UsersRef;
    private StorageReference UserProfileImageRef;

    int exists;
    String currentUserID;
    final static int Gallery_Pick = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_set_up);


        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UsersRef = FirebaseDatabase.getInstance().getReference().child("Users");
        UserProfileImageRef = FirebaseStorage.getInstance().getReference().child("Profile Images");

        UserName = (EditText) findViewById(R.id.setupUsername);
        FullName = (EditText) findViewById(R.id.setupFUsername);
        CountryName = (EditText) findViewById(R.id.country);
        SaveInformationbuttion = (Button) findViewById(R.id.save);
        loadingBar = new ProgressDialog(this);
        exists=0;

        SaveInformationbuttion.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view)
            {
                SaveAccountSetupInformation();
            }
        });

    }


    private void SaveAccountSetupInformation()
    {
        exists = 0;
        final String username = UserName.getText().toString();
        final String fullname = FullName.getText().toString();
        final String country = CountryName.getText().toString();

        if(TextUtils.isEmpty(username))
        {
            Toast.makeText(this, R.string.registration_username_noty, Toast.LENGTH_SHORT).show();
        }
        if(TextUtils.isEmpty(fullname))
        {
            Toast.makeText(this, R.string.registration_fullname_noty, Toast.LENGTH_SHORT).show();
        }
        if(TextUtils.isEmpty(country))
        {
            Toast.makeText(this, R.string.registration_country_noty, Toast.LENGTH_SHORT).show();
        }
        if(!TextUtils.isEmpty(username) && !TextUtils.isEmpty(country) && !TextUtils.isEmpty(fullname))
        {

            UsersRef.addListenerForSingleValueEvent(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if(dataSnapshot.exists()){
                        for(DataSnapshot ds : dataSnapshot.getChildren()){
                            if(ds.hasChild("username")) {
                                if (ds.child("username").getValue().toString().equals(username)) {
                                    Toast.makeText(SetUpActivity.this, R.string.registration_setup_userExist, Toast.LENGTH_SHORT).show();
                                    exists++;
                                }
                            }
                        }
                        if(exists==0){
                            loadingBar.setTitle(R.string.registration_setup_loading);
                            loadingBar.show();
                            loadingBar.setCanceledOnTouchOutside(true);

                            HashMap userMap = new HashMap();
                            userMap.put("level", "10");
                            userMap.put("metrosTotal", "0");
                            userMap.put("username", username);
                            userMap.put("fullname", fullname);
                            userMap.put("country", country);
                            userMap.put("status", "");
                            UsersRef.child(currentUserID).updateChildren(userMap).addOnCompleteListener(new OnCompleteListener() {
                                @Override
                                public void onComplete(@NonNull Task task)
                                {
                                    if(task.isSuccessful())
                                    {
                                        UsersRef.child(currentUserID).child("Level").child("actualLevel").setValue("1");
                                        UsersRef.child(currentUserID).child("Level").child("EXP").setValue("1000");
                                        UsersRef.child(currentUserID).child("Level").child("actualEXP").setValue("0");
                                        SendUserToMainActivity();
                                        Toast.makeText(SetUpActivity.this, R.string.registration_setup_result, Toast.LENGTH_LONG).show();
                                        loadingBar.dismiss();
                                    }
                                    else
                                    {
                                        String message =  task.getException().getMessage();
                                        Toast.makeText(SetUpActivity.this, "Error: " + message, Toast.LENGTH_SHORT).show();
                                        loadingBar.dismiss();
                                    }
                                }
                            });
                        }
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {

                }
            });


        }
    }



    private void SendUserToMainActivity()
    {
        Intent mainIntent = new Intent(SetUpActivity.this, MainActivity.class);
        mainIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(mainIntent);
        finish();
    }
}