package com.example.kurama.aprieta;

import android.app.ProgressDialog;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.util.HashMap;

import static android.Manifest.permission.ACCESS_FINE_LOCATION;

public class SmartChallengeActivity extends AppCompatActivity{
    private Toolbar mToolbar;

    private DatabaseReference BoulderRef, ChallengeRef, UserRef;
    private FirebaseAuth mAuth;

    private FusedLocationProviderClient client;
    private Location l;
    private float[] distance = new float[1];
    Double longitude, latitude;

    private Spinner distanceBox, difficultyBox;
    private String grade, distancess,currentUserID, profileimage, username, BoulderKey;
    private Button saveButton;
    private int distances=0;
    private boolean existe;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_smart_challenge);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users").child(currentUserID);
        BoulderRef = FirebaseDatabase.getInstance().getReference().child("Boulders");
        ChallengeRef = FirebaseDatabase.getInstance().getReference().child("Challenges");


        mToolbar =  findViewById(R.id.smartChallenge_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.smartchallenge_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        distanceBox = findViewById(R.id.distanceBox);
        difficultyBox = findViewById(R.id.difficultyBox);
        saveButton = findViewById(R.id.saveSmartChallenge);

        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, R.array.distances, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        distanceBox.setAdapter(adapter);
        distanceBox.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                distancess = parent.getItemAtPosition(position).toString();
                if(distancess.equals("5Km")){
                    distances = 5;
                }else if(distancess.equals("10Km")){
                    distances = 10;
                }else if(distancess.equals("15Km")){
                    distances = 15;
                }else if(distancess.equals("20Km")){
                    distances = 20;
                }else if(distancess.equals("25Km")){
                    distances = 25;
                }else if(distancess.equals("30Km")){
                    distances = 30;
                }else if(distancess.equals("35Km")){
                    distances = 35;
                }else if(distancess.equals("40Km")){
                    distances = 40;
                }else if(distancess.equals("45Km")){
                    distances = 45;
                }else if(distancess.equals("50Km")){
                    distances = 50;
                }

            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });

        UserRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){
                    username = dataSnapshot.child("username").getValue().toString();
                    profileimage = dataSnapshot.child("profileimage").getValue().toString();
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

        ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(this, R.array.difficulty, android.R.layout.simple_spinner_item);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        difficultyBox.setAdapter(adapter2);
        difficultyBox.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                grade = parent.getItemAtPosition(position).toString();

            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        client = LocationServices.getFusedLocationProviderClient(this);


        if (ActivityCompat.checkSelfPermission(this, ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            SendUserToMainActivity();
        }
        client.getLastLocation().addOnSuccessListener(this, new OnSuccessListener<Location>() {
            @Override
            public void onSuccess(Location location) {
                if(location==null){
                    Toast.makeText(SmartChallengeActivity.this,"Por favor enciende el GPS", Toast.LENGTH_LONG).show();
                }else{
                    System.out.println(location.toString());
                    l = new Location(location);
                    latitude=location.getLatitude();
                    longitude=location.getLongitude();
                }
            }
        });

        saveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                storeChallenge();
                Toast.makeText(SmartChallengeActivity.this,R.string.challenge_created, Toast.LENGTH_LONG).show();
                SendUserToAllChallengeListAcitivty();

            }
        });

    }

    private void storeChallenge() {
        existe=false;
        final HashMap challengeHash = new HashMap();
        final HashMap boulderHash = new HashMap();
        final HashMap participantHash = new HashMap();
        final String challengeKey = ChallengeRef.push().getKey();

        BoulderRef.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){
                    if(grade.equals("Facil")){
                        for(DataSnapshot ds : dataSnapshot.getChildren()){
                            l.distanceBetween(latitude, longitude, Double.parseDouble(ds.child("latitude").getValue().toString()), Double.parseDouble(ds.child("longitude").getValue().toString()),
                                    distance = new float[1]);
                            if((distance[0]/1000)<distances && (ds.child("grade").getValue().toString().equals("4") || ds.child("grade").getValue().toString().equals("5A") || ds.child("grade").getValue().toString().equals("5A+") ||
                                    ds.child("grade").getValue().toString().equals("5B") || ds.child("grade").getValue().toString().equals("5B+") || ds.child("grade").getValue().toString().equals("5C") || ds.child("grade").getValue().toString().equals("5C+") || ds.child("grade").getValue().toString().equals("6A"))){
                                challengeHash.put("difficulty", grade);
                                challengeHash.put("distance", distances);
                                challengeHash.put("numberOfVots", "0");
                                challengeHash.put("rate", "0");
                                challengeHash.put("userID", currentUserID);
                                challengeHash.put("username", username);
                                challengeHash.put("profileimage", profileimage);

                                BoulderKey = ds.getKey();
                                boulderHash.put("name", ds.child("name").getValue().toString());
                                boulderHash.put("location", ds.child("location").getValue().toString());
                                boulderHash.put("grade", ds.child("grade").getValue().toString());

                                participantHash.put("bouldersDone", "0");

                                ChallengeRef.child(challengeKey).updateChildren(challengeHash);
                                ChallengeRef.child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                ChallengeRef.child(challengeKey).child("Participants").child(currentUserID).updateChildren(participantHash);
                                UserRef.child("OwnChallenges").child(challengeKey).updateChildren(challengeHash);
                                UserRef.child("OwnChallenges").child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                existe=true;
                            }

                        }
                        if(existe==false) {
                            Toast.makeText(SmartChallengeActivity.this, R.string.challenge_noBoulders, Toast.LENGTH_LONG).show();
                        }

                    }else if(grade.equals("Medio")){
                        for(DataSnapshot ds : dataSnapshot.getChildren()){
                            l.distanceBetween(latitude, longitude, Double.parseDouble(ds.child("latitude").getValue().toString()), Double.parseDouble(ds.child("longitude").getValue().toString()),
                                    distance = new float[1]);
                            if((distance[0]/1000)<distances && (ds.child("grade").getValue().toString().equals("6A+") || ds.child("grade").getValue().toString().equals("6B") || ds.child("grade").getValue().toString().equals("6B+") ||
                                    ds.child("grade").getValue().toString().equals("6C") || ds.child("grade").getValue().toString().equals("6C+") || ds.child("grade").getValue().toString().equals("7A") || ds.child("grade").getValue().toString().equals("7A+") || ds.child("grade").getValue().toString().equals("7B") || ds.child("grade").getValue().toString().equals("7B+"))){
                                challengeHash.put("difficulty", grade);
                                challengeHash.put("distance", distances);
                                challengeHash.put("numberOfVots", "0");
                                challengeHash.put("rate", "0");
                                challengeHash.put("userID", currentUserID);
                                challengeHash.put("username", username);
                                challengeHash.put("profileimage", profileimage);

                                BoulderKey = ds.getKey();
                                boulderHash.put("name", ds.child("name").getValue().toString());
                                boulderHash.put("location", ds.child("location").getValue().toString());
                                boulderHash.put("grade", ds.child("grade").getValue().toString());

                                participantHash.put("bouldersDone", "0");

                                ChallengeRef.child(challengeKey).updateChildren(challengeHash);
                                ChallengeRef.child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                ChallengeRef.child(challengeKey).child("Participants").child(currentUserID).updateChildren(participantHash);
                                UserRef.child("OwnChallenges").child(challengeKey).updateChildren(challengeHash);
                                UserRef.child("OwnChallenges").child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                existe=true;

                            }

                        }
                        if(existe==false) {
                            Toast.makeText(SmartChallengeActivity.this, R.string.challenge_noBoulders, Toast.LENGTH_LONG).show();
                        }

                    }else if(grade.equals("Dificil")){
                        for(DataSnapshot ds : dataSnapshot.getChildren()){

                            l.distanceBetween(latitude, longitude, Double.parseDouble(ds.child("latitude").getValue().toString()), Double.parseDouble(ds.child("longitude").getValue().toString()),
                                    distance = new float[1]);
                            if((distance[0]/1000)<distances && (ds.child("grade").getValue().toString().equals("7C") || ds.child("grade").getValue().toString().equals("7C+") || ds.child("grade").getValue().toString().equals("8A") ||
                                    ds.child("grade").getValue().toString().equals("8A+") || ds.child("grade").getValue().toString().equals("8B") || ds.child("grade").getValue().toString().equals("8B+") || ds.child("grade").getValue().toString().equals("8C") || ds.child("grade").getValue().toString().equals("8C+"))){
                                challengeHash.put("difficulty", grade);
                                challengeHash.put("distance", distances);
                                challengeHash.put("numberOfVots", "0");
                                challengeHash.put("rate", "0");
                                challengeHash.put("userID", currentUserID);
                                challengeHash.put("username", username);
                                challengeHash.put("profileimage", profileimage);

                                BoulderKey = ds.getKey();
                                boulderHash.put("name", ds.child("name").getValue().toString());
                                boulderHash.put("location", ds.child("location").getValue().toString());
                                boulderHash.put("grade", ds.child("grade").getValue().toString());

                                participantHash.put("bouldersDone", "0");

                                ChallengeRef.child(challengeKey).updateChildren(challengeHash);
                                ChallengeRef.child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                ChallengeRef.child(challengeKey).child("Participants").child(currentUserID).updateChildren(participantHash);
                                UserRef.child("OwnChallenges").child(challengeKey).updateChildren(challengeHash);
                                UserRef.child("OwnChallenges").child(challengeKey).child("Boulders").child(BoulderKey).updateChildren(boulderHash);
                                existe=true;

                            }

                        }

                        if(existe==false) {
                            Toast.makeText(SmartChallengeActivity.this, R.string.challenge_noBoulders, Toast.LENGTH_LONG).show();
                        }

                    }

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });


    }

    private void SendUserToAllChallengeListAcitivty() {
        Intent selfIntent = new Intent(SmartChallengeActivity.this, AllChallengeListActivity.class);
        startActivity(selfIntent);
        finish();
    }
    private void SendUserToMainActivity() {
        Intent selfIntent = new Intent(SmartChallengeActivity.this, MainActivity.class);
        startActivity(selfIntent);
        finish();
    }
}
