package com.example.kurama.aprieta;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.widget.TextView;

import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

public class StatsActivity extends AppCompatActivity {
    private Toolbar mToolbar;

    private TextView metresTotal, challengeTotal, bouldersTotal;

    private FirebaseAuth mAuth;
    private DatabaseReference UserRef;

    private String currentUserID;

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_stats);

        mAuth = FirebaseAuth.getInstance();
        currentUserID = mAuth.getCurrentUser().getUid();
        UserRef = FirebaseDatabase.getInstance().getReference().child("Users").child(currentUserID);

        mToolbar = (Toolbar) findViewById(R.id.stats_toolbar);
        setSupportActionBar(mToolbar);
        getSupportActionBar().setTitle(R.string.stats_title);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        metresTotal = findViewById(R.id.totalMeter);
        challengeTotal = findViewById(R.id.totalChallenges);
        bouldersTotal = findViewById(R.id.totalBoulders);

        UserRef.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                if(dataSnapshot.exists()){
                    metresTotal.setText(dataSnapshot.child("metrosTotal").getValue().toString()+"m");
                    if(dataSnapshot.hasChild("doneChallenges")) {
                        challengeTotal.setText(String.valueOf(dataSnapshot.child("doneChallenges").getChildrenCount()));
                    }
                    if(dataSnapshot.hasChild("doneBoulders")) {
                        bouldersTotal.setText(String.valueOf(dataSnapshot.child("doneBoulders").getChildrenCount()));
                    }

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {}
        });
    }
}
